/*********************************************************************
	Rhapsody	: 6.1 
	Login		: Masood Khosroshahy
	Component	: mainComponent 
	Configuration 	: DefaultConfig
	Model Element	: Rip
//!	Generated Date	: Tue, 28, Mar 2006  
	File Path	: mainComponent/DefaultConfig/Rip.h
*********************************************************************/


#ifndef Rip_H 

#define Rip_H 

#include <oxf/oxf.h>
#include <aom/aom.h>
#include <oxf/event.h>

//## package Rip 


//#[ ignore 
#define evRIP_Rip_id 29001


#define evInit_Rip_id 29002


#define evRep_Init_Rip_id 29003


#define evTopology_Rip_id 29004


#define evTimer_Rip_id 29005
//#]

//----------------------------------------------------------------------------
// Rip.h                                                                  
//----------------------------------------------------------------------------
class iRouterScheduler1;
class iSchedulerRouter3;
class Network;
class Router;
class Scheduler;
class evInit;
class evRep_Init;
class evRIP;
class evTimer;
class evTopology;

#ifdef _OMINSTRUMENT
class OMAnimatedevInit;
#endif // _OMINSTRUMENT

#ifdef _OMINSTRUMENT
class OMAnimatedevRep_Init;
#endif // _OMINSTRUMENT

#ifdef _OMINSTRUMENT
class OMAnimatedevRIP;
#endif // _OMINSTRUMENT

#ifdef _OMINSTRUMENT
class OMAnimatedevTimer;
#endif // _OMINSTRUMENT

#ifdef _OMINSTRUMENT
class OMAnimatedevTopology;
#endif // _OMINSTRUMENT


//#[ ignore 
struct RIPLine {
    int Cost;		//## attribute Cost 
    int Destination;		//## attribute Destination 
};

struct RIPTable {
    RIPLine ArrayRIPLine[4];		//## attribute ArrayRIPLine 
};

struct RoutingLine {
    int Cost;		//## attribute Cost 
    int Destination;		//## attribute Destination 
    int NextHop;		//## attribute NextHop 
};

struct RoutingTable {
    RoutingLine ArrayRoutingLine[3];		//## attribute ArrayRoutingLine 
};

struct NeighboursTable {
    int Array[3];		//## attribute Array 
};

struct RIPMessages {
    int ArrayNumberOfLines[3];		//## attribute ArrayNumberOfLines 
    RIPTable ArrayRIPMessages[3];		//## attribute ArrayRIPMessages 
};

struct RIPMessagesArray {
    RIPTable Array[4];		//## attribute Array 
    int ArrayNbLine[4];		//## attribute ArrayNbLine 
};
//#]


//## event evRIP(int,RIPTable,int,int,int,int,int,int,int,int) 
class evRIP : public OMEvent {


////    Friends    ////
public :
    
    
#ifdef _OMINSTRUMENT
    friend  class OMAnimatedevRIP;
#endif // _OMINSTRUMENT


////    Constructors and destructors    ////
public :
    
    evRIP();
    
    evRIP(int p_NBLines, RIPTable p_msg, int p_D1, int p_C1, int p_D2, int p_C2, int p_D3, int p_C3, int p_D4, int p_C4);


////    Framework operations    ////
public :
    
    bool isTypeOf(short id) const;


////    Attributes    ////
public :
    
    int NBLines;
    RIPTable msg;
    int D1;
    int C1;
    int D2;
    int C2;
    int D3;
    int C3;
    int D4;
    int C4;

};


#ifdef _OMINSTRUMENT
//## ignore 
class OMAnimatedevRIP : virtual public AOMEvent {

    
    DECLARE_META_EVENT(evRIP)


};

#endif // _OMINSTRUMENT
//## event evInit(int) 
class evInit : public OMEvent {


////    Friends    ////
public :
    
    
#ifdef _OMINSTRUMENT
    friend  class OMAnimatedevInit;
#endif // _OMINSTRUMENT


////    Constructors and destructors    ////
public :
    
    evInit();
    
    evInit(int p_id);


////    Framework operations    ////
public :
    
    bool isTypeOf(short id) const;


////    Attributes    ////
public :
    
    int id;

};


#ifdef _OMINSTRUMENT
//## ignore 
class OMAnimatedevInit : virtual public AOMEvent {

    
    DECLARE_META_EVENT(evInit)


};

#endif // _OMINSTRUMENT
//## event evRep_Init() 
class evRep_Init : public OMEvent {


////    Friends    ////
public :
    
    
#ifdef _OMINSTRUMENT
    friend  class OMAnimatedevRep_Init;
#endif // _OMINSTRUMENT


////    Constructors and destructors    ////
public :
    
    evRep_Init();


////    Framework operations    ////
public :
    
    bool isTypeOf(short id) const;


};


#ifdef _OMINSTRUMENT
//## ignore 
class OMAnimatedevRep_Init : virtual public AOMEvent {

    
    DECLARE_META_EVENT(evRep_Init)


};

#endif // _OMINSTRUMENT
//## event evTopology(int,int,int) 
class evTopology : public OMEvent {


////    Friends    ////
public :
    
    
#ifdef _OMINSTRUMENT
    friend  class OMAnimatedevTopology;
#endif // _OMINSTRUMENT


////    Constructors and destructors    ////
public :
    
    evTopology();
    
    evTopology(int p_arg1, int p_arg2, int p_arg3);


////    Framework operations    ////
public :
    
    bool isTypeOf(short id) const;


////    Attributes    ////
public :
    
    int arg1;
    int arg2;
    int arg3;

};


#ifdef _OMINSTRUMENT
//## ignore 
class OMAnimatedevTopology : virtual public AOMEvent {

    
    DECLARE_META_EVENT(evTopology)


};

#endif // _OMINSTRUMENT
//## event evTimer(int) 
class evTimer : public OMEvent {


////    Friends    ////
public :
    
    
#ifdef _OMINSTRUMENT
    friend  class OMAnimatedevTimer;
#endif // _OMINSTRUMENT


////    Constructors and destructors    ////
public :
    
    evTimer();
    
    evTimer(int p_arg);


////    Framework operations    ////
public :
    
    bool isTypeOf(short id) const;


////    Attributes    ////
public :
    
    int arg;

};


#ifdef _OMINSTRUMENT
//## ignore 
class OMAnimatedevTimer : virtual public AOMEvent {

    
    DECLARE_META_EVENT(evTimer)


};

#endif // _OMINSTRUMENT


#endif  
/*********************************************************************
	File Path	: mainComponent/DefaultConfig/Rip.h
*********************************************************************/

