/********************************************************************
	Rhapsody	: 6.1 
	Login		: Masood Khosroshahy
	Component	: mainComponent 
	Configuration 	: DefaultConfig
	Model Element	: Scheduler
//!	Generated Date	: Tue, 28, Mar 2006  
	File Path	: mainComponent/DefaultConfig/Scheduler.cpp
*********************************************************************/


//#[ ignore 
#define NAMESPACE_PREFIX 


#define _OMSTATECHART_ANIMATED 
//#]

#include "Scheduler.h"

//## package Rip 


//#[ ignore 
#define Rip_Scheduler_Scheduler_SERIALIZE OM_NO_OP


#define Rip_Scheduler_sendingTimerToAll_SERIALIZE OM_NO_OP


#define Rip_Scheduler_setReplyTo_SERIALIZE aomsmethod->addAttribute("p", x2String(p));
//#]

//----------------------------------------------------------------------------
// Scheduler.cpp                                                                  
//----------------------------------------------------------------------------
DECLARE_META_PACKAGE(Rip)
//## class Scheduler 



Scheduler::Scheduler(IOxfActive* theActiveContext) : NbNodes(4) ,replyTo(NULL) ,ripMessageSendingIteration(1) ,time(15) {
    NOTIFY_REACTIVE_CONSTRUCTOR(Scheduler, Scheduler(), 0, Rip_Scheduler_Scheduler_SERIALIZE);
    setActiveContext(theActiveContext, false);
    initRelations();
    initStatechart();
}

Scheduler::~Scheduler() {
    NOTIFY_DESTRUCTOR(~Scheduler, false);
    cleanUpRelations();
    cancelTimeouts();
}

Scheduler::pRouter1_C* Scheduler::getPRouter1() const {
    return pRouter1;
}

Scheduler::pRouter1_C* Scheduler::get_pRouter1() const {
    return pRouter1;
}

Scheduler::pRouter1_C* Scheduler::newPRouter1() {
    pRouter1 = new Scheduler::pRouter1_C;
    return pRouter1;
}

void Scheduler::deletePRouter1() {
    delete pRouter1;
    pRouter1 = NULL;
}

Scheduler::pRouter2_C* Scheduler::getPRouter2() const {
    return pRouter2;
}

Scheduler::pRouter2_C* Scheduler::get_pRouter2() const {
    return pRouter2;
}

Scheduler::pRouter2_C* Scheduler::newPRouter2() {
    pRouter2 = new Scheduler::pRouter2_C;
    return pRouter2;
}

void Scheduler::deletePRouter2() {
    delete pRouter2;
    pRouter2 = NULL;
}

Scheduler::pRouter3_C* Scheduler::getPRouter3() const {
    return pRouter3;
}

Scheduler::pRouter3_C* Scheduler::get_pRouter3() const {
    return pRouter3;
}

Scheduler::pRouter3_C* Scheduler::newPRouter3() {
    pRouter3 = new Scheduler::pRouter3_C;
    return pRouter3;
}

void Scheduler::deletePRouter3() {
    delete pRouter3;
    pRouter3 = NULL;
}

Scheduler::pRouter4_C* Scheduler::getPRouter4() const {
    return pRouter4;
}

Scheduler::pRouter4_C* Scheduler::get_pRouter4() const {
    return pRouter4;
}

Scheduler::pRouter4_C* Scheduler::newPRouter4() {
    pRouter4 = new Scheduler::pRouter4_C;
    return pRouter4;
}

void Scheduler::deletePRouter4() {
    delete pRouter4;
    pRouter4 = NULL;
}

Scheduler::pTimerOut_C* Scheduler::getPTimerOut() const {
    return pTimerOut;
}

Scheduler::pTimerOut_C* Scheduler::get_pTimerOut() const {
    return pTimerOut;
}

Scheduler::pTimerOut_C* Scheduler::newPTimerOut() {
    pTimerOut = new Scheduler::pTimerOut_C;
    return pTimerOut;
}

void Scheduler::deletePTimerOut() {
    delete pTimerOut;
    pTimerOut = NULL;
}

Scheduler::pTimerIn_C* Scheduler::getPTimerIn() const {
    return pTimerIn;
}

Scheduler::pTimerIn_C* Scheduler::get_pTimerIn() const {
    return pTimerIn;
}

Scheduler::pTimerIn_C* Scheduler::newPTimerIn() {
    pTimerIn = new Scheduler::pTimerIn_C;
    return pTimerIn;
}

void Scheduler::deletePTimerIn() {
    delete pTimerIn;
    pTimerIn = NULL;
}

void Scheduler::sendingTimerToAll() {
    NOTIFY_OPERATION(sendingTimerToAll, sendingTimerToAll(), 0, Rip_Scheduler_sendingTimerToAll_SERIALIZE);
    //#[ operation sendingTimerToAll() 
    OUT_PORT(pRouter1)->GEN(evTimer(time));
    OUT_PORT(pRouter2)->GEN(evTimer(time));
    OUT_PORT(pRouter3)->GEN(evTimer(time));
    OUT_PORT(pRouter4)->GEN(evTimer(time));
    
    //#]
}

void Scheduler::setReplyTo(void * p) {
    NOTIFY_OPERATION(setReplyTo, setReplyTo(void *), 1, Rip_Scheduler_setReplyTo_SERIALIZE);
    //#[ operation setReplyTo(void *) 
    replyTo = static_cast<pRouter_CPtr>(p);
    //#]
}

int Scheduler::getNbNodes() const {
    return NbNodes;
}

void Scheduler::setNbNodes(int p_NbNodes) {
    NbNodes = p_NbNodes;
}

Scheduler::pRouter_CPtr Scheduler::getReplyTo() const {
    return replyTo;
}

void Scheduler::setReplyTo(Scheduler::pRouter_CPtr p_replyTo) {
    replyTo = p_replyTo;
}

int Scheduler::getRipMessageSendingIteration() const {
    return ripMessageSendingIteration;
}

void Scheduler::setRipMessageSendingIteration(int p_ripMessageSendingIteration) {
    ripMessageSendingIteration = p_ripMessageSendingIteration;
}

int Scheduler::getTime() const {
    return time;
}

void Scheduler::setTime(int p_time) {
    time = p_time;
}

void Scheduler::rootState_entDef() {
    {
        NOTIFY_STATE_ENTERED("ROOT");
        mainState_entDef();
    }
}

IOxfReactive::TakeEventStatus Scheduler::rootState_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (rootState_active) {
        case mainState:
        {
            res = mainState_processEvent();
            break;
        }
        default:
            break;
    }
    return res;
}

bool Scheduler::mainState_isCompleted() {
    if(IS_COMPLETED(state_80) == false)
        {
            return false;
        }
    return true;
}

IOxfReactive::TakeEventStatus Scheduler::mainState_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(state_80_processEvent() > 0)
        {
            res = eventConsumed;
            if(!IS_IN(mainState))
                {
                    return res;
                }
        }
    if(state_81_processEvent() > 0)
        {
            res = eventConsumed;
            if(!IS_IN(mainState))
                {
                    return res;
                }
        }
    
    return res;
}

IOxfReactive::TakeEventStatus Scheduler::state_81_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (state_81_active) {
        case InitialTimerState:
        {
            res = InitialTimerState_handleEvent();
            break;
        }
        case evTimerSent:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("14");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.state_81.evTimerSent");
                    //#[ transition 14 
                    ripMessageSendingIteration++;
                    time = ripMessageSendingIteration*15;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.state_81.InitialTimerState");
                    pushNullTransition();
                    state_81_subState = InitialTimerState;
                    state_81_active = InitialTimerState;
                    InitialTimerState_timeout = scheduleTimeout(time , "ROOT.mainState.state_81.InitialTimerState");
                    NOTIFY_TRANSITION_TERMINATED("14");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case NewTopologyAt75:
        {
            if(IS_EVENT_TYPE_OF(OMTimeoutEventId))
                {
                    if(getCurrentEvent() == NewTopologyAt75_timeout)
                        {
                            NOTIFY_TRANSITION_STARTED("19");
                            if(NewTopologyAt75_timeout != NULL)
                                {
                                    NewTopologyAt75_timeout->cancel();
                                    NewTopologyAt75_timeout = NULL;
                                }
                            NOTIFY_STATE_EXITED("ROOT.mainState.state_81.NewTopologyAt75");
                            //#[ transition 19 
                            
                            sendingTimerToAll();
                            //#]
                            NOTIFY_STATE_ENTERED("ROOT.mainState.state_81.evTimerSent");
                            pushNullTransition();
                            state_81_subState = evTimerSent;
                            state_81_active = evTimerSent;
                            NOTIFY_TRANSITION_TERMINATED("19");
                            res = eventConsumed;
                        }
                }
            
            
            break;
        }
        case NewTopologyAt135:
        {
            if(IS_EVENT_TYPE_OF(OMTimeoutEventId))
                {
                    if(getCurrentEvent() == NewTopologyAt135_timeout)
                        {
                            NOTIFY_TRANSITION_STARTED("20");
                            if(NewTopologyAt135_timeout != NULL)
                                {
                                    NewTopologyAt135_timeout->cancel();
                                    NewTopologyAt135_timeout = NULL;
                                }
                            NOTIFY_STATE_EXITED("ROOT.mainState.state_81.NewTopologyAt135");
                            //#[ transition 20 
                            
                            sendingTimerToAll();
                            //#]
                            NOTIFY_STATE_ENTERED("ROOT.mainState.state_81.evTimerSent");
                            pushNullTransition();
                            state_81_subState = evTimerSent;
                            state_81_active = evTimerSent;
                            NOTIFY_TRANSITION_TERMINATED("20");
                            res = eventConsumed;
                        }
                }
            
            
            break;
        }
        case NewTopologyAt195:
        {
            if(IS_EVENT_TYPE_OF(OMTimeoutEventId))
                {
                    if(getCurrentEvent() == NewTopologyAt195_timeout)
                        {
                            NOTIFY_TRANSITION_STARTED("21");
                            if(NewTopologyAt195_timeout != NULL)
                                {
                                    NewTopologyAt195_timeout->cancel();
                                    NewTopologyAt195_timeout = NULL;
                                }
                            NOTIFY_STATE_EXITED("ROOT.mainState.state_81.NewTopologyAt195");
                            //#[ transition 21 
                            
                            sendingTimerToAll();
                            //#]
                            NOTIFY_STATE_ENTERED("ROOT.mainState.state_81.evTimerSent");
                            pushNullTransition();
                            state_81_subState = evTimerSent;
                            state_81_active = evTimerSent;
                            NOTIFY_TRANSITION_TERMINATED("21");
                            res = eventConsumed;
                        }
                }
            
            
            break;
        }
        default:
            break;
    }
    return res;
}

IOxfReactive::TakeEventStatus Scheduler::state_80_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (state_80_active) {
        case Initial:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.0");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Initial");
                    //#[ transition ROOT.mainState.state_80.InitializingState.0 
                    OUT_PORT(pRouter1)->GEN(evInit(1));
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.IDSentToR1");
                    pushNullTransition();
                    InitializingState_subState = IDSentToR1;
                    state_80_active = IDSentToR1;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.0");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case IDSentToR1:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.1");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.IDSentToR1");
                    //#[ transition ROOT.mainState.state_80.InitializingState.1 
                    OUT_PORT(pRouter2)->GEN(evInit(2));
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.IDSentToR2");
                    pushNullTransition();
                    InitializingState_subState = IDSentToR2;
                    state_80_active = IDSentToR2;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.1");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case IDSentToR2:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.2");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.IDSentToR2");
                    //#[ transition ROOT.mainState.state_80.InitializingState.2 
                    OUT_PORT(pRouter3)->GEN(evInit(3));
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.IDSentToR3");
                    pushNullTransition();
                    InitializingState_subState = IDSentToR3;
                    state_80_active = IDSentToR3;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.2");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case IDSentToR3:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.3");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.IDSentToR3");
                    //#[ transition ROOT.mainState.state_80.InitializingState.3 
                    OUT_PORT(pRouter4)->GEN(evInit(4));
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.IDSentToR4");
                    pushNullTransition();
                    InitializingState_subState = IDSentToR4;
                    state_80_active = IDSentToR4;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.3");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case IDSentToR4:
        {
            res = IDSentToR4_handleEvent();
            break;
        }
        case AllAckReceived:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.23");
                    InitializingState_exit();
                    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.Wait_42_down");
                    state_80_subState = Wait_42_down;
                    state_80_active = Wait_42_down;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.23");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case Topology:
        {
            res = Topology_processEvent();
            break;
        }
        case Wait_42_down:
        {
            if(IS_EVENT_TYPE_OF(evTimer_Rip_id))
                {
                    OMSETPARAMS(evTimer);
                    //## transition 1 
                    if(IS_PORT(pTimerIn))
                        {
                            NOTIFY_TRANSITION_STARTED("1");
                            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.Wait_42_down");
                            //#[ transition 1 
                            
                            OUT_PORT(pRouter2)->GEN(evTopology(1,3,-4));
                            //#]
                            NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.TopologyToR2_42");
                            pushNullTransition();
                            state_80_subState = TopologyToR2_42;
                            state_80_active = TopologyToR2_42;
                            NOTIFY_TRANSITION_TERMINATED("1");
                            res = eventConsumed;
                        }
                }
            
            
            break;
        }
        case TopologyToR2_42:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("2");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.state_80.TopologyToR2_42");
                    //#[ transition 2 
                    OUT_PORT(pRouter4)->GEN(evTopology(1,-2,0));
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.TopologyToR4_42");
                    pushNullTransition();
                    state_80_subState = TopologyToR4_42;
                    state_80_active = TopologyToR4_42;
                    NOTIFY_TRANSITION_TERMINATED("2");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case TopologyToR4_42:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("7");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.state_80.TopologyToR4_42");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.Wait_41_Down");
                    state_80_subState = Wait_41_Down;
                    state_80_active = Wait_41_Down;
                    NOTIFY_TRANSITION_TERMINATED("7");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case TopologyToR4_41:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("9");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.state_80.TopologyToR4_41");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.Wait_32_Down");
                    state_80_subState = Wait_32_Down;
                    state_80_active = Wait_32_Down;
                    NOTIFY_TRANSITION_TERMINATED("9");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case TopologyToR1_41:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("3");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.state_80.TopologyToR1_41");
                    //#[ transition 3 
                    OUT_PORT(pRouter4)->GEN(evTopology(-1,-2,0));
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.TopologyToR4_41");
                    pushNullTransition();
                    state_80_subState = TopologyToR4_41;
                    state_80_active = TopologyToR4_41;
                    NOTIFY_TRANSITION_TERMINATED("3");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case Wait_41_Down:
        {
            if(IS_EVENT_TYPE_OF(evTimer_Rip_id))
                {
                    OMSETPARAMS(evTimer);
                    //## transition 4 
                    if(IS_PORT(pTimerIn))
                        {
                            NOTIFY_TRANSITION_STARTED("4");
                            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.Wait_41_Down");
                            //#[ transition 4 
                            
                            OUT_PORT(pRouter1)->GEN(evTopology(2,-4,0));
                            //#]
                            NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.TopologyToR1_41");
                            pushNullTransition();
                            state_80_subState = TopologyToR1_41;
                            state_80_active = TopologyToR1_41;
                            NOTIFY_TRANSITION_TERMINATED("4");
                            res = eventConsumed;
                        }
                }
            
            
            break;
        }
        case Wait_32_Down:
        {
            if(IS_EVENT_TYPE_OF(evTimer_Rip_id))
                {
                    OMSETPARAMS(evTimer);
                    //## transition 6 
                    if(IS_PORT(pTimerIn))
                        {
                            NOTIFY_TRANSITION_STARTED("6");
                            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.Wait_32_Down");
                            //#[ transition 6 
                            
                            OUT_PORT(pRouter2)->GEN(evTopology(1,-4,-3));
                            //#]
                            NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.TopologyToR2_32");
                            pushNullTransition();
                            state_80_subState = TopologyToR2_32;
                            state_80_active = TopologyToR2_32;
                            NOTIFY_TRANSITION_TERMINATED("6");
                            res = eventConsumed;
                        }
                }
            
            
            break;
        }
        case TopologyToR3_32:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("11");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.state_80.TopologyToR3_32");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.state_74");
                    state_80_subState = state_74;
                    state_80_active = state_74;
                    NOTIFY_TRANSITION_TERMINATED("11");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case TopologyToR2_32:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("5");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.state_80.TopologyToR2_32");
                    //#[ transition 5 
                    OUT_PORT(pRouter3)->GEN(evTopology(-2,0,0));
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.TopologyToR3_32");
                    pushNullTransition();
                    state_80_subState = TopologyToR3_32;
                    state_80_active = TopologyToR3_32;
                    NOTIFY_TRANSITION_TERMINATED("5");
                    res = eventConsumed;
                }
            
            
            break;
        }
        
        default:
            break;
    }
    return res;
}

IOxfReactive::TakeEventStatus Scheduler::Topology_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(state_60_processEvent() > 0)
        {
            res = eventConsumed;
            if(!IS_IN(Topology))
                {
                    return res;
                }
        }
    if(state_61_processEvent() > 0)
        {
            res = eventConsumed;
            if(!IS_IN(Topology))
                {
                    return res;
                }
        }
    if(state_62_processEvent() > 0)
        {
            res = eventConsumed;
            if(!IS_IN(Topology))
                {
                    return res;
                }
        }
    if(state_63_processEvent() > 0)
        {
            res = eventConsumed;
            if(!IS_IN(Topology))
                {
                    return res;
                }
        }
    if(res == eventNotConsumed)
        {
            res = Topology_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus Scheduler::state_63_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (state_63_active) {
        case Ack3:
        {
            res = Ack3_handleEvent();
            break;
        }
        case TopologyToR3:
        {
            if(IS_EVENT_TYPE_OF(evRep_Init_Rip_id))
                {
                    //## transition ROOT.mainState.state_80.InitializingState.10 
                    if(IS_PORT(pRouter3))
                        {
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.10");
                            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_63.TopologyToR3");
                            NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_63.Ack3");
                            pushNullTransition();
                            state_63_subState = Ack3;
                            state_63_active = Ack3;
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.10");
                            res = eventConsumed;
                        }
                }
            
            
            break;
        }
        case SendingToR3:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.9");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_63.SendingToR3");
                    //#[ transition ROOT.mainState.state_80.InitializingState.9 
                    OUT_PORT(pRouter3)->GEN(evTopology(2,0,0));
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_63.TopologyToR3");
                    state_63_subState = TopologyToR3;
                    state_63_active = TopologyToR3;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.9");
                    res = eventConsumed;
                }
            
            
            break;
        }
        default:
            break;
    }
    return res;
}

IOxfReactive::TakeEventStatus Scheduler::state_62_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (state_62_active) {
        case Ack2:
        {
            res = Ack2_handleEvent();
            break;
        }
        case TopologyToR2:
        {
            if(IS_EVENT_TYPE_OF(evRep_Init_Rip_id))
                {
                    //## transition ROOT.mainState.state_80.InitializingState.8 
                    if(IS_PORT(pRouter2))
                        {
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.8");
                            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_62.TopologyToR2");
                            NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_62.Ack2");
                            pushNullTransition();
                            state_62_subState = Ack2;
                            state_62_active = Ack2;
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.8");
                            res = eventConsumed;
                        }
                }
            
            
            break;
        }
        case SendingToR2:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.7");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_62.SendingToR2");
                    //#[ transition ROOT.mainState.state_80.InitializingState.7 
                    OUT_PORT(pRouter2)->GEN(evTopology(1,3,4));
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_62.TopologyToR2");
                    state_62_subState = TopologyToR2;
                    state_62_active = TopologyToR2;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.7");
                    res = eventConsumed;
                }
            
            
            break;
        }
        default:
            break;
    }
    return res;
}

IOxfReactive::TakeEventStatus Scheduler::state_61_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (state_61_active) {
        case Ack4:
        {
            res = Ack4_handleEvent();
            break;
        }
        case TopologyTo4:
        {
            if(IS_EVENT_TYPE_OF(evRep_Init_Rip_id))
                {
                    //## transition ROOT.mainState.state_80.InitializingState.12 
                    if(IS_PORT(pRouter4))
                        {
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.12");
                            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_61.TopologyTo4");
                            NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_61.Ack4");
                            pushNullTransition();
                            state_61_subState = Ack4;
                            state_61_active = Ack4;
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.12");
                            res = eventConsumed;
                        }
                }
            
            
            break;
        }
        case SendingToR4:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.11");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_61.SendingToR4");
                    //#[ transition ROOT.mainState.state_80.InitializingState.11 
                    OUT_PORT(pRouter4)->GEN(evTopology(1,2,0));
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_61.TopologyTo4");
                    state_61_subState = TopologyTo4;
                    state_61_active = TopologyTo4;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.11");
                    res = eventConsumed;
                }
            
            
            break;
        }
        default:
            break;
    }
    return res;
}

IOxfReactive::TakeEventStatus Scheduler::state_60_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (state_60_active) {
        case Ack1:
        {
            res = Ack1_handleEvent();
            break;
        }
        case TopologyToR1:
        {
            if(IS_EVENT_TYPE_OF(evRep_Init_Rip_id))
                {
                    //## transition ROOT.mainState.state_80.InitializingState.6 
                    if(IS_PORT(pRouter1))
                        {
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.6");
                            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_60.TopologyToR1");
                            NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_60.Ack1");
                            pushNullTransition();
                            state_60_subState = Ack1;
                            state_60_active = Ack1;
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.6");
                            res = eventConsumed;
                        }
                }
            
            
            break;
        }
        case SendingToR1:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.5");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_60.SendingToR1");
                    //#[ transition ROOT.mainState.state_80.InitializingState.5 
                    OUT_PORT(pRouter1)->GEN(evTopology(2,4,0));
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_60.TopologyToR1");
                    state_60_subState = TopologyToR1;
                    state_60_active = TopologyToR1;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.5");
                    res = eventConsumed;
                }
            
            
            break;
        }
        default:
            break;
    }
    return res;
}

void Scheduler::initRelations() {
    pRouter1 = newPRouter1();
    pRouter2 = newPRouter2();
    pRouter3 = newPRouter3();
    pRouter4 = newPRouter4();
    pTimerOut = newPTimerOut();
    pTimerIn = newPTimerIn();
    if(getPRouter1())
       getPRouter1()->connectScheduler(this);
    if(getPRouter2())
       getPRouter2()->connectScheduler(this);
    if(getPRouter3())
       getPRouter3()->connectScheduler(this);
    if(getPRouter4())
       getPRouter4()->connectScheduler(this);
    if(getPTimerOut())
       getPTimerOut()->connectScheduler(this);
    if(getPTimerIn())
       getPTimerIn()->connectScheduler(this);
}

void Scheduler::initStatechart() {
    rootState_subState = OMNonState;
    rootState_active = OMNonState;
    state_81_subState = OMNonState;
    state_81_active = OMNonState;
    NewTopologyAt75_timeout = NULL;
    NewTopologyAt195_timeout = NULL;
    NewTopologyAt135_timeout = NULL;
    InitialTimerState_timeout = NULL;
    state_80_subState = OMNonState;
    state_80_active = OMNonState;
    InitializingState_subState = OMNonState;
    state_63_subState = OMNonState;
    state_63_active = OMNonState;
    state_62_subState = OMNonState;
    state_62_active = OMNonState;
    state_61_subState = OMNonState;
    state_61_active = OMNonState;
    state_60_subState = OMNonState;
    state_60_active = OMNonState;
}

void Scheduler::cleanUpRelations() {
    {
        deletePTimerIn();
    }
    {
        deletePTimerOut();
    }
    {
        deletePRouter4();
    }
    {
        deletePRouter3();
    }
    {
        deletePRouter2();
    }
    {
        deletePRouter1();
    }
}

void Scheduler::cancelTimeouts() {
    if(NewTopologyAt75_timeout != NULL)
        {
            NewTopologyAt75_timeout->cancel();
            NewTopologyAt75_timeout = NULL;
        }
    if(NewTopologyAt195_timeout != NULL)
        {
            NewTopologyAt195_timeout->cancel();
            NewTopologyAt195_timeout = NULL;
        }
    if(NewTopologyAt135_timeout != NULL)
        {
            NewTopologyAt135_timeout->cancel();
            NewTopologyAt135_timeout = NULL;
        }
    if(InitialTimerState_timeout != NULL)
        {
            InitialTimerState_timeout->cancel();
            InitialTimerState_timeout = NULL;
        }
}

bool Scheduler::cancelTimeout(const IOxfTimeout* arg) {
    bool res = false;
    if(NewTopologyAt75_timeout == arg)
        {
            NewTopologyAt75_timeout = NULL;
            res = true;
        }
    if(NewTopologyAt195_timeout == arg)
        {
            NewTopologyAt195_timeout = NULL;
            res = true;
        }
    if(NewTopologyAt135_timeout == arg)
        {
            NewTopologyAt135_timeout = NULL;
            res = true;
        }
    if(InitialTimerState_timeout == arg)
        {
            InitialTimerState_timeout = NULL;
            res = true;
        }
    return res;
}

bool Scheduler::startBehavior() {
    bool done = false;
    done = OMReactive::startBehavior();
    return done;
}

void Scheduler::state_60_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_60");
    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.17");
    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_60.SendingToR1");
    pushNullTransition();
    state_60_subState = SendingToR1;
    state_60_active = SendingToR1;
    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.17");
}

void Scheduler::state_81_exit() {
    switch (state_81_subState) {
        case InitialTimerState:
        {
            popNullTransition();
            if(InitialTimerState_timeout != NULL)
                {
                    InitialTimerState_timeout->cancel();
                    InitialTimerState_timeout = NULL;
                }
            NOTIFY_STATE_EXITED("ROOT.mainState.state_81.InitialTimerState");
            break;
        }
        case evTimerSent:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.state_81.evTimerSent");
            break;
        }
        case NewTopologyAt75:
        {
            if(NewTopologyAt75_timeout != NULL)
                {
                    NewTopologyAt75_timeout->cancel();
                    NewTopologyAt75_timeout = NULL;
                }
            NOTIFY_STATE_EXITED("ROOT.mainState.state_81.NewTopologyAt75");
            break;
        }
        case NewTopologyAt135:
        {
            if(NewTopologyAt135_timeout != NULL)
                {
                    NewTopologyAt135_timeout->cancel();
                    NewTopologyAt135_timeout = NULL;
                }
            NOTIFY_STATE_EXITED("ROOT.mainState.state_81.NewTopologyAt135");
            break;
        }
        case NewTopologyAt195:
        {
            if(NewTopologyAt195_timeout != NULL)
                {
                    NewTopologyAt195_timeout->cancel();
                    NewTopologyAt195_timeout = NULL;
                }
            NOTIFY_STATE_EXITED("ROOT.mainState.state_81.NewTopologyAt195");
            break;
        }
        default:
            break;
    }
    state_81_subState = OMNonState;
    NOTIFY_STATE_EXITED("ROOT.mainState.state_81");
}

void Scheduler::state_63_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_63");
    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.19");
    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_63.SendingToR3");
    pushNullTransition();
    state_63_subState = SendingToR3;
    state_63_active = SendingToR3;
    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.19");
}

void Scheduler::state_80_exit() {
    switch (state_80_subState) {
        case InitializingState:
        {
            InitializingState_exit();
            break;
        }
        case Wait_42_down:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.Wait_42_down");
            break;
        }
        case TopologyToR2_42:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.TopologyToR2_42");
            break;
        }
        case TopologyToR4_42:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.TopologyToR4_42");
            break;
        }
        case TopologyToR4_41:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.TopologyToR4_41");
            break;
        }
        case TopologyToR1_41:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.TopologyToR1_41");
            break;
        }
        case Wait_41_Down:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.Wait_41_Down");
            break;
        }
        case Wait_32_Down:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.Wait_32_Down");
            break;
        }
        case TopologyToR3_32:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.TopologyToR3_32");
            break;
        }
        case TopologyToR2_32:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.TopologyToR2_32");
            break;
        }
        case state_74:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.state_74");
            break;
        }
        default:
            break;
    }
    state_80_subState = OMNonState;
    NOTIFY_STATE_EXITED("ROOT.mainState.state_80");
}

void Scheduler::mainState_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState");
    rootState_subState = mainState;
    rootState_active = mainState;
    state_80_entDef();
    state_81_entDef();
}

IOxfReactive::TakeEventStatus Scheduler::Ack2_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition ROOT.mainState.state_80.InitializingState.22 
            if(IS_IN(Ack1) && IS_IN(Ack3) && IS_IN(Ack4))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.22");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.13");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.14");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.15");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.16");
                    Topology_exit();
                    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.AllAckReceived");
                    pushNullTransition();
                    InitializingState_subState = AllAckReceived;
                    state_80_active = AllAckReceived;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.16");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.15");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.14");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.13");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.22");
                    res = eventConsumed;
                }
        }
    
    
    return res;
}

void Scheduler::state_61_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_61");
    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.20");
    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_61.SendingToR4");
    pushNullTransition();
    state_61_subState = SendingToR4;
    state_61_active = SendingToR4;
    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.20");
}

IOxfReactive::TakeEventStatus Scheduler::Topology_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    return res;
}

IOxfReactive::TakeEventStatus Scheduler::IDSentToR4_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            res = IDSentToR4TakeNull();
        }
    
    
    return res;
}

IOxfReactive::TakeEventStatus Scheduler::Ack3_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition ROOT.mainState.state_80.InitializingState.22 
            if(IS_IN(Ack1) && IS_IN(Ack4) && IS_IN(Ack2))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.22");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.13");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.14");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.15");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.16");
                    Topology_exit();
                    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.AllAckReceived");
                    pushNullTransition();
                    InitializingState_subState = AllAckReceived;
                    state_80_active = AllAckReceived;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.16");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.15");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.14");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.13");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.22");
                    res = eventConsumed;
                }
        }
    
    
    return res;
}

void Scheduler::state_80_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80");
    NOTIFY_TRANSITION_STARTED("15");
    InitializingState_entDef();
    NOTIFY_TRANSITION_TERMINATED("15");
}

IOxfReactive::TakeEventStatus Scheduler::InitialTimerState_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMTimeoutEventId))
        {
            if(getCurrentEvent() == InitialTimerState_timeout)
                {
                    NOTIFY_TRANSITION_STARTED("13");
                    popNullTransition();
                    if(InitialTimerState_timeout != NULL)
                        {
                            InitialTimerState_timeout->cancel();
                            InitialTimerState_timeout = NULL;
                        }
                    NOTIFY_STATE_EXITED("ROOT.mainState.state_81.InitialTimerState");
                    //#[ transition 13 
                    
                    if ( (time)%30 == 0 )
                    sendingTimerToAll();
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.state_81.evTimerSent");
                    pushNullTransition();
                    state_81_subState = evTimerSent;
                    state_81_active = evTimerSent;
                    NOTIFY_TRANSITION_TERMINATED("13");
                    res = eventConsumed;
                }
        }
    else if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition 16 
            if(time == 135)
                {
                    NOTIFY_TRANSITION_STARTED("16");
                    popNullTransition();
                    if(InitialTimerState_timeout != NULL)
                        {
                            InitialTimerState_timeout->cancel();
                            InitialTimerState_timeout = NULL;
                        }
                    NOTIFY_STATE_EXITED("ROOT.mainState.state_81.InitialTimerState");
                    //#[ transition 16 
                    
                    OUT_PORT(pTimerOut)->GEN(evTimer(time));
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.state_81.NewTopologyAt135");
                    state_81_subState = NewTopologyAt135;
                    state_81_active = NewTopologyAt135;
                    NewTopologyAt135_timeout = scheduleTimeout(time +1, "ROOT.mainState.state_81.NewTopologyAt135");
                    NOTIFY_TRANSITION_TERMINATED("16");
                    res = eventConsumed;
                }
            else
                {
                    //## transition 17 
                    if(time == 75)
                        {
                            NOTIFY_TRANSITION_STARTED("17");
                            popNullTransition();
                            if(InitialTimerState_timeout != NULL)
                                {
                                    InitialTimerState_timeout->cancel();
                                    InitialTimerState_timeout = NULL;
                                }
                            NOTIFY_STATE_EXITED("ROOT.mainState.state_81.InitialTimerState");
                            //#[ transition 17 
                            
                            OUT_PORT(pTimerOut)->GEN(evTimer(time));
                            //#]
                            NOTIFY_STATE_ENTERED("ROOT.mainState.state_81.NewTopologyAt75");
                            state_81_subState = NewTopologyAt75;
                            state_81_active = NewTopologyAt75;
                            NewTopologyAt75_timeout = scheduleTimeout(time +1, "ROOT.mainState.state_81.NewTopologyAt75");
                            NOTIFY_TRANSITION_TERMINATED("17");
                            res = eventConsumed;
                        }
                    else
                        {
                            //## transition 18 
                            if(time == 195)
                                {
                                    NOTIFY_TRANSITION_STARTED("18");
                                    popNullTransition();
                                    if(InitialTimerState_timeout != NULL)
                                        {
                                            InitialTimerState_timeout->cancel();
                                            InitialTimerState_timeout = NULL;
                                        }
                                    NOTIFY_STATE_EXITED("ROOT.mainState.state_81.InitialTimerState");
                                    //#[ transition 18 
                                    
                                    OUT_PORT(pTimerOut)->GEN(evTimer(time));
                                    //#]
                                    NOTIFY_STATE_ENTERED("ROOT.mainState.state_81.NewTopologyAt195");
                                    state_81_subState = NewTopologyAt195;
                                    state_81_active = NewTopologyAt195;
                                    NewTopologyAt195_timeout = scheduleTimeout(time +1, "ROOT.mainState.state_81.NewTopologyAt195");
                                    NOTIFY_TRANSITION_TERMINATED("18");
                                    res = eventConsumed;
                                }
                        }
                }
        }
    
    
    return res;
}

void Scheduler::Topology_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology");
    InitializingState_subState = Topology;
    state_80_active = Topology;
    state_60_entDef();
    state_61_entDef();
    state_62_entDef();
    state_63_entDef();
}

void Scheduler::InitializingState_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState");
    state_80_subState = InitializingState;
    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.4");
    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Initial");
    pushNullTransition();
    InitializingState_subState = Initial;
    state_80_active = Initial;
    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.4");
}

void Scheduler::state_62_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_62");
    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.18");
    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_62.SendingToR2");
    pushNullTransition();
    state_62_subState = SendingToR2;
    state_62_active = SendingToR2;
    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.18");
}

void Scheduler::InitializingState_exit() {
    switch (InitializingState_subState) {
        case Initial:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Initial");
            break;
        }
        case IDSentToR1:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.IDSentToR1");
            break;
        }
        case IDSentToR2:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.IDSentToR2");
            break;
        }
        case IDSentToR3:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.IDSentToR3");
            break;
        }
        case IDSentToR4:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.IDSentToR4");
            break;
        }
        case AllAckReceived:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.AllAckReceived");
            break;
        }
        case Topology:
        {
            Topology_exit();
            break;
        }
        default:
            break;
    }
    InitializingState_subState = OMNonState;
    NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState");
}

IOxfReactive::TakeEventStatus Scheduler::IDSentToR4TakeNull() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.21");
    popNullTransition();
    NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.IDSentToR4");
    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology");
    InitializingState_subState = Topology;
    state_80_active = Topology;
    state_60_entDef();
    state_62_entDef();
    state_63_entDef();
    state_61_entDef();
    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.21");
    res = eventConsumed;
    return res;
}

void Scheduler::Topology_exit() {
    switch (state_60_subState) {
        case Ack1:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_60.Ack1");
            break;
        }
        case TopologyToR1:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_60.TopologyToR1");
            break;
        }
        case SendingToR1:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_60.SendingToR1");
            break;
        }
        default:
            break;
    }
    state_60_subState = OMNonState;
    NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_60");
    switch (state_61_subState) {
        case Ack4:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_61.Ack4");
            break;
        }
        case TopologyTo4:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_61.TopologyTo4");
            break;
        }
        case SendingToR4:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_61.SendingToR4");
            break;
        }
        default:
            break;
    }
    state_61_subState = OMNonState;
    NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_61");
    switch (state_62_subState) {
        case Ack2:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_62.Ack2");
            break;
        }
        case TopologyToR2:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_62.TopologyToR2");
            break;
        }
        case SendingToR2:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_62.SendingToR2");
            break;
        }
        default:
            break;
    }
    state_62_subState = OMNonState;
    NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_62");
    switch (state_63_subState) {
        case Ack3:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_63.Ack3");
            break;
        }
        case TopologyToR3:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_63.TopologyToR3");
            break;
        }
        case SendingToR3:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_63.SendingToR3");
            break;
        }
        default:
            break;
    }
    state_63_subState = OMNonState;
    NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_63");
    NOTIFY_STATE_EXITED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology");
}

IOxfReactive::TakeEventStatus Scheduler::Ack1_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition ROOT.mainState.state_80.InitializingState.22 
            if(IS_IN(Ack3) && IS_IN(Ack4) && IS_IN(Ack2))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.22");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.13");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.14");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.15");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.16");
                    Topology_exit();
                    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.AllAckReceived");
                    pushNullTransition();
                    InitializingState_subState = AllAckReceived;
                    state_80_active = AllAckReceived;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.16");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.15");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.14");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.13");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.22");
                    res = eventConsumed;
                }
        }
    
    
    return res;
}

IOxfReactive::TakeEventStatus Scheduler::Ack4_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition ROOT.mainState.state_80.InitializingState.22 
            if(IS_IN(Ack1) && IS_IN(Ack3) && IS_IN(Ack2))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.22");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.13");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.14");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.15");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.state_80.InitializingState.16");
                    Topology_exit();
                    NOTIFY_STATE_ENTERED("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.AllAckReceived");
                    pushNullTransition();
                    InitializingState_subState = AllAckReceived;
                    state_80_active = AllAckReceived;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.16");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.15");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.14");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.13");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.state_80.InitializingState.22");
                    res = eventConsumed;
                }
        }
    
    
    return res;
}

void Scheduler::state_81_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.state_81");
    NOTIFY_TRANSITION_STARTED("12");
    NOTIFY_STATE_ENTERED("ROOT.mainState.state_81.InitialTimerState");
    pushNullTransition();
    state_81_subState = InitialTimerState;
    state_81_active = InitialTimerState;
    InitialTimerState_timeout = scheduleTimeout(time , "ROOT.mainState.state_81.InitialTimerState");
    NOTIFY_TRANSITION_TERMINATED("12");
}

void Scheduler::mainState_exit() {
    state_80_exit();
    state_81_exit();
    NOTIFY_STATE_EXITED("ROOT.mainState");
}





Scheduler::pRouter1_C::pRouter1_C() {
    initRelations();
}

Scheduler::pRouter1_C::~pRouter1_C() {
}

void Scheduler::pRouter1_C::connectScheduler(Scheduler* part) {
    //#[ operation connectScheduler(Scheduler*) 
    InBound.setItsIRouterScheduler1(part);
    InBound.setPort(this); // for IS_PORT macro support
    
    //#]
}

iRouterScheduler1* Scheduler::pRouter1_C::getItsIRouterScheduler1() {
    //#[ operation getItsIRouterScheduler1() 
    return &InBound;
    //#]
}

iSchedulerRouter3* Scheduler::pRouter1_C::getItsISchedulerRouter3() {
    //#[ operation getItsISchedulerRouter3() 
    return &OutBound;
    //#]
}

void Scheduler::pRouter1_C::setItsIRouterScheduler1(iRouterScheduler1* p_iRouterScheduler1) {
    //#[ operation setItsIRouterScheduler1(iRouterScheduler1*) 
    InBound.setItsIRouterScheduler1(p_iRouterScheduler1);
    //#]
}

void Scheduler::pRouter1_C::setItsISchedulerRouter3(OMReactive* p_iSchedulerRouter3) {
    //#[ operation setItsISchedulerRouter3(OMReactive*) 
    OutBound.setItsISchedulerRouter3(p_iSchedulerRouter3);
    //#]
}

Scheduler::pRouter1_C::InBound_C* Scheduler::pRouter1_C::getInBound() const {
    return (Scheduler::pRouter1_C::InBound_C*) &InBound;
}

Scheduler::pRouter1_C::OutBound_C* Scheduler::pRouter1_C::getOutBound() const {
    return (Scheduler::pRouter1_C::OutBound_C*) &OutBound;
}

void Scheduler::pRouter1_C::destroy() {
}

void Scheduler::pRouter1_C::initRelations() {
    InBound._setPort(this);
}





Scheduler::pRouter1_C::InBound_C::InBound_C() {
    itsIRouterScheduler1 = NULL;
    port = NULL;
}

Scheduler::pRouter1_C::InBound_C::~InBound_C() {
    cleanUpRelations();
}

bool Scheduler::pRouter1_C::InBound_C::send(IOxfEvent* event, const IOxfEventGenerationParams& params) {
    //#[ operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
    bool res = false;
    if (event != NULL) {
      event->setPort(getPort());
      	if (itsIRouterScheduler1 != NULL){
    	     if (event->isTypeOf(evRep_Init_Rip_id)){
         		res = itsIRouterScheduler1->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evTimer_Rip_id)){
         		res = itsIRouterScheduler1->send(event, params);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

bool Scheduler::pRouter1_C::InBound_C::send(IOxfEvent* event) {
    //#[ operation send(IOxfEvent*) 
    bool res = false;
    if (event != NULL) {
      event->setPort(getPort());
      	if (itsIRouterScheduler1 != NULL){
    	     if (event->isTypeOf(evRep_Init_Rip_id)){
         		res = itsIRouterScheduler1->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evTimer_Rip_id)){
         		res = itsIRouterScheduler1->send(event);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

iRouterScheduler1* Scheduler::pRouter1_C::InBound_C::getItsIRouterScheduler1() const {
    return itsIRouterScheduler1;
}

void Scheduler::pRouter1_C::InBound_C::setItsIRouterScheduler1(iRouterScheduler1* p_iRouterScheduler1) {
    itsIRouterScheduler1 = p_iRouterScheduler1;
}

Scheduler::pRouter1_C* Scheduler::pRouter1_C::InBound_C::getPort() const {
    return port;
}

void Scheduler::pRouter1_C::InBound_C::__setPort(Scheduler::pRouter1_C* p_pRouter1_C) {
    port = p_pRouter1_C;
}

void Scheduler::pRouter1_C::InBound_C::_setPort(Scheduler::pRouter1_C* p_pRouter1_C) {
    __setPort(p_pRouter1_C);
}

void Scheduler::pRouter1_C::InBound_C::setPort(Scheduler::pRouter1_C* p_pRouter1_C) {
    _setPort(p_pRouter1_C);
}

void Scheduler::pRouter1_C::InBound_C::_clearPort() {
    port = NULL;
}

void Scheduler::pRouter1_C::InBound_C::cleanUpRelations() {
    if(itsIRouterScheduler1 != NULL)
        {
            itsIRouterScheduler1 = NULL;
        }
    if(port != NULL)
        {
            Scheduler::pRouter1_C::InBound_C* p_InBound = port->getInBound();
            port = NULL;
        }
}






Scheduler::pRouter1_C::OutBound_C::OutBound_C() {
    itsISchedulerRouter3 = NULL;
}

Scheduler::pRouter1_C::OutBound_C::~OutBound_C() {
    cleanUpRelations();
}

bool Scheduler::pRouter1_C::OutBound_C::send(IOxfEvent* event, const IOxfEventGenerationParams& params) {
    //#[ operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
    bool res = false;
    if (event != NULL) {
      	if (itsISchedulerRouter3 != NULL){
    	     if (event->isTypeOf(evTopology_Rip_id)){
         		res = itsISchedulerRouter3->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evInit_Rip_id)){
         		res = itsISchedulerRouter3->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evTimer_Rip_id)){
         		res = itsISchedulerRouter3->send(event, params);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

bool Scheduler::pRouter1_C::OutBound_C::send(IOxfEvent* event) {
    //#[ operation send(IOxfEvent*) 
    bool res = false;
    if (event != NULL) {
      	if (itsISchedulerRouter3 != NULL){
    	     if (event->isTypeOf(evTopology_Rip_id)){
         		res = itsISchedulerRouter3->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evInit_Rip_id)){
         		res = itsISchedulerRouter3->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evTimer_Rip_id)){
         		res = itsISchedulerRouter3->send(event);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

OMReactive* Scheduler::pRouter1_C::OutBound_C::getItsISchedulerRouter3() const {
    return itsISchedulerRouter3;
}

void Scheduler::pRouter1_C::OutBound_C::setItsISchedulerRouter3(OMReactive* p_OMReactive) {
    itsISchedulerRouter3 = p_OMReactive;
}

void Scheduler::pRouter1_C::OutBound_C::cleanUpRelations() {
    if(itsISchedulerRouter3 != NULL)
        {
            itsISchedulerRouter3 = NULL;
        }
}







Scheduler::pRouter2_C::pRouter2_C() {
    initRelations();
}

Scheduler::pRouter2_C::~pRouter2_C() {
}

void Scheduler::pRouter2_C::connectScheduler(Scheduler* part) {
    //#[ operation connectScheduler(Scheduler*) 
    InBound.setItsIRouterScheduler1(part);
    InBound.setPort(this); // for IS_PORT macro support
    
    //#]
}

iRouterScheduler1* Scheduler::pRouter2_C::getItsIRouterScheduler1() {
    //#[ operation getItsIRouterScheduler1() 
    return &InBound;
    //#]
}

iSchedulerRouter3* Scheduler::pRouter2_C::getItsISchedulerRouter3() {
    //#[ operation getItsISchedulerRouter3() 
    return &OutBound;
    //#]
}

void Scheduler::pRouter2_C::setItsIRouterScheduler1(iRouterScheduler1* p_iRouterScheduler1) {
    //#[ operation setItsIRouterScheduler1(iRouterScheduler1*) 
    InBound.setItsIRouterScheduler1(p_iRouterScheduler1);
    //#]
}

void Scheduler::pRouter2_C::setItsISchedulerRouter3(OMReactive* p_iSchedulerRouter3) {
    //#[ operation setItsISchedulerRouter3(OMReactive*) 
    OutBound.setItsISchedulerRouter3(p_iSchedulerRouter3);
    //#]
}

Scheduler::pRouter2_C::InBound_C* Scheduler::pRouter2_C::getInBound() const {
    return (Scheduler::pRouter2_C::InBound_C*) &InBound;
}

Scheduler::pRouter2_C::OutBound_C* Scheduler::pRouter2_C::getOutBound() const {
    return (Scheduler::pRouter2_C::OutBound_C*) &OutBound;
}

void Scheduler::pRouter2_C::destroy() {
}

void Scheduler::pRouter2_C::initRelations() {
    InBound._setPort(this);
}





Scheduler::pRouter2_C::InBound_C::InBound_C() {
    itsIRouterScheduler1 = NULL;
    port = NULL;
}

Scheduler::pRouter2_C::InBound_C::~InBound_C() {
    cleanUpRelations();
}

bool Scheduler::pRouter2_C::InBound_C::send(IOxfEvent* event, const IOxfEventGenerationParams& params) {
    //#[ operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
    bool res = false;
    if (event != NULL) {
      event->setPort(getPort());
      	if (itsIRouterScheduler1 != NULL){
    	     if (event->isTypeOf(evRep_Init_Rip_id)){
         		res = itsIRouterScheduler1->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evTimer_Rip_id)){
         		res = itsIRouterScheduler1->send(event, params);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

bool Scheduler::pRouter2_C::InBound_C::send(IOxfEvent* event) {
    //#[ operation send(IOxfEvent*) 
    bool res = false;
    if (event != NULL) {
      event->setPort(getPort());
      	if (itsIRouterScheduler1 != NULL){
    	     if (event->isTypeOf(evRep_Init_Rip_id)){
         		res = itsIRouterScheduler1->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evTimer_Rip_id)){
         		res = itsIRouterScheduler1->send(event);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

iRouterScheduler1* Scheduler::pRouter2_C::InBound_C::getItsIRouterScheduler1() const {
    return itsIRouterScheduler1;
}

void Scheduler::pRouter2_C::InBound_C::setItsIRouterScheduler1(iRouterScheduler1* p_iRouterScheduler1) {
    itsIRouterScheduler1 = p_iRouterScheduler1;
}

Scheduler::pRouter2_C* Scheduler::pRouter2_C::InBound_C::getPort() const {
    return port;
}

void Scheduler::pRouter2_C::InBound_C::__setPort(Scheduler::pRouter2_C* p_pRouter2_C) {
    port = p_pRouter2_C;
}

void Scheduler::pRouter2_C::InBound_C::_setPort(Scheduler::pRouter2_C* p_pRouter2_C) {
    __setPort(p_pRouter2_C);
}

void Scheduler::pRouter2_C::InBound_C::setPort(Scheduler::pRouter2_C* p_pRouter2_C) {
    _setPort(p_pRouter2_C);
}

void Scheduler::pRouter2_C::InBound_C::_clearPort() {
    port = NULL;
}

void Scheduler::pRouter2_C::InBound_C::cleanUpRelations() {
    if(itsIRouterScheduler1 != NULL)
        {
            itsIRouterScheduler1 = NULL;
        }
    if(port != NULL)
        {
            Scheduler::pRouter2_C::InBound_C* p_InBound = port->getInBound();
            port = NULL;
        }
}






Scheduler::pRouter2_C::OutBound_C::OutBound_C() {
    itsISchedulerRouter3 = NULL;
}

Scheduler::pRouter2_C::OutBound_C::~OutBound_C() {
    cleanUpRelations();
}

bool Scheduler::pRouter2_C::OutBound_C::send(IOxfEvent* event, const IOxfEventGenerationParams& params) {
    //#[ operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
    bool res = false;
    if (event != NULL) {
      	if (itsISchedulerRouter3 != NULL){
    	     if (event->isTypeOf(evTopology_Rip_id)){
         		res = itsISchedulerRouter3->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evInit_Rip_id)){
         		res = itsISchedulerRouter3->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evTimer_Rip_id)){
         		res = itsISchedulerRouter3->send(event, params);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

bool Scheduler::pRouter2_C::OutBound_C::send(IOxfEvent* event) {
    //#[ operation send(IOxfEvent*) 
    bool res = false;
    if (event != NULL) {
      	if (itsISchedulerRouter3 != NULL){
    	     if (event->isTypeOf(evTopology_Rip_id)){
         		res = itsISchedulerRouter3->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evInit_Rip_id)){
         		res = itsISchedulerRouter3->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evTimer_Rip_id)){
         		res = itsISchedulerRouter3->send(event);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

OMReactive* Scheduler::pRouter2_C::OutBound_C::getItsISchedulerRouter3() const {
    return itsISchedulerRouter3;
}

void Scheduler::pRouter2_C::OutBound_C::setItsISchedulerRouter3(OMReactive* p_OMReactive) {
    itsISchedulerRouter3 = p_OMReactive;
}

void Scheduler::pRouter2_C::OutBound_C::cleanUpRelations() {
    if(itsISchedulerRouter3 != NULL)
        {
            itsISchedulerRouter3 = NULL;
        }
}







Scheduler::pRouter3_C::pRouter3_C() {
    initRelations();
}

Scheduler::pRouter3_C::~pRouter3_C() {
}

void Scheduler::pRouter3_C::connectScheduler(Scheduler* part) {
    //#[ operation connectScheduler(Scheduler*) 
    InBound.setItsIRouterScheduler1(part);
    InBound.setPort(this); // for IS_PORT macro support
    
    //#]
}

iRouterScheduler1* Scheduler::pRouter3_C::getItsIRouterScheduler1() {
    //#[ operation getItsIRouterScheduler1() 
    return &InBound;
    //#]
}

iSchedulerRouter3* Scheduler::pRouter3_C::getItsISchedulerRouter3() {
    //#[ operation getItsISchedulerRouter3() 
    return &OutBound;
    //#]
}

void Scheduler::pRouter3_C::setItsIRouterScheduler1(iRouterScheduler1* p_iRouterScheduler1) {
    //#[ operation setItsIRouterScheduler1(iRouterScheduler1*) 
    InBound.setItsIRouterScheduler1(p_iRouterScheduler1);
    //#]
}

void Scheduler::pRouter3_C::setItsISchedulerRouter3(OMReactive* p_iSchedulerRouter3) {
    //#[ operation setItsISchedulerRouter3(OMReactive*) 
    OutBound.setItsISchedulerRouter3(p_iSchedulerRouter3);
    //#]
}

Scheduler::pRouter3_C::InBound_C* Scheduler::pRouter3_C::getInBound() const {
    return (Scheduler::pRouter3_C::InBound_C*) &InBound;
}

Scheduler::pRouter3_C::OutBound_C* Scheduler::pRouter3_C::getOutBound() const {
    return (Scheduler::pRouter3_C::OutBound_C*) &OutBound;
}

void Scheduler::pRouter3_C::destroy() {
}

void Scheduler::pRouter3_C::initRelations() {
    InBound._setPort(this);
}





Scheduler::pRouter3_C::InBound_C::InBound_C() {
    itsIRouterScheduler1 = NULL;
    port = NULL;
}

Scheduler::pRouter3_C::InBound_C::~InBound_C() {
    cleanUpRelations();
}

bool Scheduler::pRouter3_C::InBound_C::send(IOxfEvent* event, const IOxfEventGenerationParams& params) {
    //#[ operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
    bool res = false;
    if (event != NULL) {
      event->setPort(getPort());
      	if (itsIRouterScheduler1 != NULL){
    	     if (event->isTypeOf(evRep_Init_Rip_id)){
         		res = itsIRouterScheduler1->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evTimer_Rip_id)){
         		res = itsIRouterScheduler1->send(event, params);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

bool Scheduler::pRouter3_C::InBound_C::send(IOxfEvent* event) {
    //#[ operation send(IOxfEvent*) 
    bool res = false;
    if (event != NULL) {
      event->setPort(getPort());
      	if (itsIRouterScheduler1 != NULL){
    	     if (event->isTypeOf(evRep_Init_Rip_id)){
         		res = itsIRouterScheduler1->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evTimer_Rip_id)){
         		res = itsIRouterScheduler1->send(event);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

iRouterScheduler1* Scheduler::pRouter3_C::InBound_C::getItsIRouterScheduler1() const {
    return itsIRouterScheduler1;
}

void Scheduler::pRouter3_C::InBound_C::setItsIRouterScheduler1(iRouterScheduler1* p_iRouterScheduler1) {
    itsIRouterScheduler1 = p_iRouterScheduler1;
}

Scheduler::pRouter3_C* Scheduler::pRouter3_C::InBound_C::getPort() const {
    return port;
}

void Scheduler::pRouter3_C::InBound_C::__setPort(Scheduler::pRouter3_C* p_pRouter3_C) {
    port = p_pRouter3_C;
}

void Scheduler::pRouter3_C::InBound_C::_setPort(Scheduler::pRouter3_C* p_pRouter3_C) {
    __setPort(p_pRouter3_C);
}

void Scheduler::pRouter3_C::InBound_C::setPort(Scheduler::pRouter3_C* p_pRouter3_C) {
    _setPort(p_pRouter3_C);
}

void Scheduler::pRouter3_C::InBound_C::_clearPort() {
    port = NULL;
}

void Scheduler::pRouter3_C::InBound_C::cleanUpRelations() {
    if(itsIRouterScheduler1 != NULL)
        {
            itsIRouterScheduler1 = NULL;
        }
    if(port != NULL)
        {
            Scheduler::pRouter3_C::InBound_C* p_InBound = port->getInBound();
            port = NULL;
        }
}






Scheduler::pRouter3_C::OutBound_C::OutBound_C() {
    itsISchedulerRouter3 = NULL;
}

Scheduler::pRouter3_C::OutBound_C::~OutBound_C() {
    cleanUpRelations();
}

bool Scheduler::pRouter3_C::OutBound_C::send(IOxfEvent* event, const IOxfEventGenerationParams& params) {
    //#[ operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
    bool res = false;
    if (event != NULL) {
      	if (itsISchedulerRouter3 != NULL){
    	     if (event->isTypeOf(evTopology_Rip_id)){
         		res = itsISchedulerRouter3->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evInit_Rip_id)){
         		res = itsISchedulerRouter3->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evTimer_Rip_id)){
         		res = itsISchedulerRouter3->send(event, params);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

bool Scheduler::pRouter3_C::OutBound_C::send(IOxfEvent* event) {
    //#[ operation send(IOxfEvent*) 
    bool res = false;
    if (event != NULL) {
      	if (itsISchedulerRouter3 != NULL){
    	     if (event->isTypeOf(evTopology_Rip_id)){
         		res = itsISchedulerRouter3->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evInit_Rip_id)){
         		res = itsISchedulerRouter3->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evTimer_Rip_id)){
         		res = itsISchedulerRouter3->send(event);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

OMReactive* Scheduler::pRouter3_C::OutBound_C::getItsISchedulerRouter3() const {
    return itsISchedulerRouter3;
}

void Scheduler::pRouter3_C::OutBound_C::setItsISchedulerRouter3(OMReactive* p_OMReactive) {
    itsISchedulerRouter3 = p_OMReactive;
}

void Scheduler::pRouter3_C::OutBound_C::cleanUpRelations() {
    if(itsISchedulerRouter3 != NULL)
        {
            itsISchedulerRouter3 = NULL;
        }
}







Scheduler::pRouter4_C::pRouter4_C() {
    initRelations();
}

Scheduler::pRouter4_C::~pRouter4_C() {
}

void Scheduler::pRouter4_C::connectScheduler(Scheduler* part) {
    //#[ operation connectScheduler(Scheduler*) 
    InBound.setItsIRouterScheduler1(part);
    InBound.setPort(this); // for IS_PORT macro support
    
    //#]
}

iRouterScheduler1* Scheduler::pRouter4_C::getItsIRouterScheduler1() {
    //#[ operation getItsIRouterScheduler1() 
    return &InBound;
    //#]
}

iSchedulerRouter3* Scheduler::pRouter4_C::getItsISchedulerRouter3() {
    //#[ operation getItsISchedulerRouter3() 
    return &OutBound;
    //#]
}

void Scheduler::pRouter4_C::setItsIRouterScheduler1(iRouterScheduler1* p_iRouterScheduler1) {
    //#[ operation setItsIRouterScheduler1(iRouterScheduler1*) 
    InBound.setItsIRouterScheduler1(p_iRouterScheduler1);
    //#]
}

void Scheduler::pRouter4_C::setItsISchedulerRouter3(OMReactive* p_iSchedulerRouter3) {
    //#[ operation setItsISchedulerRouter3(OMReactive*) 
    OutBound.setItsISchedulerRouter3(p_iSchedulerRouter3);
    //#]
}

Scheduler::pRouter4_C::InBound_C* Scheduler::pRouter4_C::getInBound() const {
    return (Scheduler::pRouter4_C::InBound_C*) &InBound;
}

Scheduler::pRouter4_C::OutBound_C* Scheduler::pRouter4_C::getOutBound() const {
    return (Scheduler::pRouter4_C::OutBound_C*) &OutBound;
}

void Scheduler::pRouter4_C::destroy() {
}

void Scheduler::pRouter4_C::initRelations() {
    InBound._setPort(this);
}





Scheduler::pRouter4_C::InBound_C::InBound_C() {
    itsIRouterScheduler1 = NULL;
    port = NULL;
}

Scheduler::pRouter4_C::InBound_C::~InBound_C() {
    cleanUpRelations();
}

bool Scheduler::pRouter4_C::InBound_C::send(IOxfEvent* event, const IOxfEventGenerationParams& params) {
    //#[ operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
    bool res = false;
    if (event != NULL) {
      event->setPort(getPort());
      	if (itsIRouterScheduler1 != NULL){
    	     if (event->isTypeOf(evRep_Init_Rip_id)){
         		res = itsIRouterScheduler1->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evTimer_Rip_id)){
         		res = itsIRouterScheduler1->send(event, params);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

bool Scheduler::pRouter4_C::InBound_C::send(IOxfEvent* event) {
    //#[ operation send(IOxfEvent*) 
    bool res = false;
    if (event != NULL) {
      event->setPort(getPort());
      	if (itsIRouterScheduler1 != NULL){
    	     if (event->isTypeOf(evRep_Init_Rip_id)){
         		res = itsIRouterScheduler1->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evTimer_Rip_id)){
         		res = itsIRouterScheduler1->send(event);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

iRouterScheduler1* Scheduler::pRouter4_C::InBound_C::getItsIRouterScheduler1() const {
    return itsIRouterScheduler1;
}

void Scheduler::pRouter4_C::InBound_C::setItsIRouterScheduler1(iRouterScheduler1* p_iRouterScheduler1) {
    itsIRouterScheduler1 = p_iRouterScheduler1;
}

Scheduler::pRouter4_C* Scheduler::pRouter4_C::InBound_C::getPort() const {
    return port;
}

void Scheduler::pRouter4_C::InBound_C::__setPort(Scheduler::pRouter4_C* p_pRouter4_C) {
    port = p_pRouter4_C;
}

void Scheduler::pRouter4_C::InBound_C::_setPort(Scheduler::pRouter4_C* p_pRouter4_C) {
    __setPort(p_pRouter4_C);
}

void Scheduler::pRouter4_C::InBound_C::setPort(Scheduler::pRouter4_C* p_pRouter4_C) {
    _setPort(p_pRouter4_C);
}

void Scheduler::pRouter4_C::InBound_C::_clearPort() {
    port = NULL;
}

void Scheduler::pRouter4_C::InBound_C::cleanUpRelations() {
    if(itsIRouterScheduler1 != NULL)
        {
            itsIRouterScheduler1 = NULL;
        }
    if(port != NULL)
        {
            Scheduler::pRouter4_C::InBound_C* p_InBound = port->getInBound();
            port = NULL;
        }
}






Scheduler::pRouter4_C::OutBound_C::OutBound_C() {
    itsISchedulerRouter3 = NULL;
}

Scheduler::pRouter4_C::OutBound_C::~OutBound_C() {
    cleanUpRelations();
}

bool Scheduler::pRouter4_C::OutBound_C::send(IOxfEvent* event, const IOxfEventGenerationParams& params) {
    //#[ operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
    bool res = false;
    if (event != NULL) {
      	if (itsISchedulerRouter3 != NULL){
    	     if (event->isTypeOf(evTopology_Rip_id)){
         		res = itsISchedulerRouter3->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evInit_Rip_id)){
         		res = itsISchedulerRouter3->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evTimer_Rip_id)){
         		res = itsISchedulerRouter3->send(event, params);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

bool Scheduler::pRouter4_C::OutBound_C::send(IOxfEvent* event) {
    //#[ operation send(IOxfEvent*) 
    bool res = false;
    if (event != NULL) {
      	if (itsISchedulerRouter3 != NULL){
    	     if (event->isTypeOf(evTopology_Rip_id)){
         		res = itsISchedulerRouter3->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evInit_Rip_id)){
         		res = itsISchedulerRouter3->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evTimer_Rip_id)){
         		res = itsISchedulerRouter3->send(event);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

OMReactive* Scheduler::pRouter4_C::OutBound_C::getItsISchedulerRouter3() const {
    return itsISchedulerRouter3;
}

void Scheduler::pRouter4_C::OutBound_C::setItsISchedulerRouter3(OMReactive* p_OMReactive) {
    itsISchedulerRouter3 = p_OMReactive;
}

void Scheduler::pRouter4_C::OutBound_C::cleanUpRelations() {
    if(itsISchedulerRouter3 != NULL)
        {
            itsISchedulerRouter3 = NULL;
        }
}







Scheduler::pTimerOut_C::pTimerOut_C() {
}

Scheduler::pTimerOut_C::~pTimerOut_C() {
}

void Scheduler::pTimerOut_C::connectScheduler(Scheduler* part) {
    //#[ operation connectScheduler(Scheduler*) 
    InBound.setItsDefaultProvidedInterface(part);
    InBound.setPort(this); // for IS_PORT macro support
    
    //#]
}






Scheduler::pTimerIn_C::pTimerIn_C() {
}

Scheduler::pTimerIn_C::~pTimerIn_C() {
}

void Scheduler::pTimerIn_C::connectScheduler(Scheduler* part) {
    //#[ operation connectScheduler(Scheduler*) 
    InBound.setItsDefaultProvidedInterface(part);
    InBound.setPort(this); // for IS_PORT macro support
    
    //#]
}




#ifdef _OMINSTRUMENT


void OMAnimatedScheduler::serializeAttributes(AOMSAttributes* aomsAttributes) const {
    aomsAttributes->addAttribute("replyTo", x2String(myReal->replyTo));
    aomsAttributes->addAttribute("ripMessageSendingIteration", x2String(myReal->ripMessageSendingIteration));
    aomsAttributes->addAttribute("time", x2String(myReal->time));
    aomsAttributes->addAttribute("NbNodes", x2String(myReal->NbNodes));
    OMAnimatediRouterScheduler1::serializeAttributes(aomsAttributes);
}

void OMAnimatedScheduler::serializeRelations(AOMSRelations* aomsRelations) const {
    OMAnimatediRouterScheduler1::serializeRelations(aomsRelations);
}

void OMAnimatedScheduler::rootState_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT");
    switch (myReal->rootState_subState) {
        case Scheduler::mainState:
        {
            mainState_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedScheduler::mainState_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState");
    state_80_serializeStates(aomsState);
    state_81_serializeStates(aomsState);
}

void OMAnimatedScheduler::state_81_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_81");
    switch (myReal->state_81_subState) {
        case Scheduler::InitialTimerState:
        {
            InitialTimerState_serializeStates(aomsState);
            break;
        }
        case Scheduler::evTimerSent:
        {
            evTimerSent_serializeStates(aomsState);
            break;
        }
        case Scheduler::NewTopologyAt75:
        {
            NewTopologyAt75_serializeStates(aomsState);
            break;
        }
        case Scheduler::NewTopologyAt135:
        {
            NewTopologyAt135_serializeStates(aomsState);
            break;
        }
        case Scheduler::NewTopologyAt195:
        {
            NewTopologyAt195_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedScheduler::NewTopologyAt75_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_81.NewTopologyAt75");
}

void OMAnimatedScheduler::NewTopologyAt195_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_81.NewTopologyAt195");
}

void OMAnimatedScheduler::NewTopologyAt135_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_81.NewTopologyAt135");
}

void OMAnimatedScheduler::InitialTimerState_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_81.InitialTimerState");
}

void OMAnimatedScheduler::evTimerSent_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_81.evTimerSent");
}

void OMAnimatedScheduler::state_80_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80");
    switch (myReal->state_80_subState) {
        case Scheduler::InitializingState:
        {
            InitializingState_serializeStates(aomsState);
            break;
        }
        case Scheduler::Wait_42_down:
        {
            Wait_42_down_serializeStates(aomsState);
            break;
        }
        case Scheduler::TopologyToR2_42:
        {
            TopologyToR2_42_serializeStates(aomsState);
            break;
        }
        case Scheduler::TopologyToR4_42:
        {
            TopologyToR4_42_serializeStates(aomsState);
            break;
        }
        case Scheduler::TopologyToR4_41:
        {
            TopologyToR4_41_serializeStates(aomsState);
            break;
        }
        case Scheduler::TopologyToR1_41:
        {
            TopologyToR1_41_serializeStates(aomsState);
            break;
        }
        case Scheduler::Wait_41_Down:
        {
            Wait_41_Down_serializeStates(aomsState);
            break;
        }
        case Scheduler::Wait_32_Down:
        {
            Wait_32_Down_serializeStates(aomsState);
            break;
        }
        case Scheduler::TopologyToR3_32:
        {
            TopologyToR3_32_serializeStates(aomsState);
            break;
        }
        case Scheduler::TopologyToR2_32:
        {
            TopologyToR2_32_serializeStates(aomsState);
            break;
        }
        case Scheduler::state_74:
        {
            state_74_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedScheduler::Wait_42_down_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.Wait_42_down");
}

void OMAnimatedScheduler::Wait_41_Down_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.Wait_41_Down");
}

void OMAnimatedScheduler::Wait_32_Down_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.Wait_32_Down");
}

void OMAnimatedScheduler::TopologyToR4_42_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.TopologyToR4_42");
}

void OMAnimatedScheduler::TopologyToR4_41_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.TopologyToR4_41");
}

void OMAnimatedScheduler::TopologyToR3_32_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.TopologyToR3_32");
}

void OMAnimatedScheduler::TopologyToR2_42_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.TopologyToR2_42");
}

void OMAnimatedScheduler::TopologyToR2_32_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.TopologyToR2_32");
}

void OMAnimatedScheduler::TopologyToR1_41_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.TopologyToR1_41");
}

void OMAnimatedScheduler::state_74_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.state_74");
}

void OMAnimatedScheduler::InitializingState_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState");
    switch (myReal->InitializingState_subState) {
        case Scheduler::Initial:
        {
            Initial_serializeStates(aomsState);
            break;
        }
        case Scheduler::IDSentToR1:
        {
            IDSentToR1_serializeStates(aomsState);
            break;
        }
        case Scheduler::IDSentToR2:
        {
            IDSentToR2_serializeStates(aomsState);
            break;
        }
        case Scheduler::IDSentToR3:
        {
            IDSentToR3_serializeStates(aomsState);
            break;
        }
        case Scheduler::IDSentToR4:
        {
            IDSentToR4_serializeStates(aomsState);
            break;
        }
        case Scheduler::AllAckReceived:
        {
            AllAckReceived_serializeStates(aomsState);
            break;
        }
        case Scheduler::Topology:
        {
            Topology_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedScheduler::Topology_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology");
    state_60_serializeStates(aomsState);
    state_61_serializeStates(aomsState);
    state_62_serializeStates(aomsState);
    state_63_serializeStates(aomsState);
}

void OMAnimatedScheduler::state_63_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_63");
    switch (myReal->state_63_subState) {
        case Scheduler::Ack3:
        {
            Ack3_serializeStates(aomsState);
            break;
        }
        case Scheduler::TopologyToR3:
        {
            TopologyToR3_serializeStates(aomsState);
            break;
        }
        case Scheduler::SendingToR3:
        {
            SendingToR3_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedScheduler::TopologyToR3_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_63.TopologyToR3");
}

void OMAnimatedScheduler::SendingToR3_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_63.SendingToR3");
}

void OMAnimatedScheduler::Ack3_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_63.Ack3");
}

void OMAnimatedScheduler::state_62_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_62");
    switch (myReal->state_62_subState) {
        case Scheduler::Ack2:
        {
            Ack2_serializeStates(aomsState);
            break;
        }
        case Scheduler::TopologyToR2:
        {
            TopologyToR2_serializeStates(aomsState);
            break;
        }
        case Scheduler::SendingToR2:
        {
            SendingToR2_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedScheduler::TopologyToR2_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_62.TopologyToR2");
}

void OMAnimatedScheduler::SendingToR2_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_62.SendingToR2");
}

void OMAnimatedScheduler::Ack2_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_62.Ack2");
}

void OMAnimatedScheduler::state_61_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_61");
    switch (myReal->state_61_subState) {
        case Scheduler::Ack4:
        {
            Ack4_serializeStates(aomsState);
            break;
        }
        case Scheduler::TopologyTo4:
        {
            TopologyTo4_serializeStates(aomsState);
            break;
        }
        case Scheduler::SendingToR4:
        {
            SendingToR4_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedScheduler::TopologyTo4_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_61.TopologyTo4");
}

void OMAnimatedScheduler::SendingToR4_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_61.SendingToR4");
}

void OMAnimatedScheduler::Ack4_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_61.Ack4");
}

void OMAnimatedScheduler::state_60_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_60");
    switch (myReal->state_60_subState) {
        case Scheduler::Ack1:
        {
            Ack1_serializeStates(aomsState);
            break;
        }
        case Scheduler::TopologyToR1:
        {
            TopologyToR1_serializeStates(aomsState);
            break;
        }
        case Scheduler::SendingToR1:
        {
            SendingToR1_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedScheduler::TopologyToR1_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_60.TopologyToR1");
}

void OMAnimatedScheduler::SendingToR1_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_60.SendingToR1");
}

void OMAnimatedScheduler::Ack1_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Topology.state_60.Ack1");
}

void OMAnimatedScheduler::Initial_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.Initial");
}

void OMAnimatedScheduler::IDSentToR4_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.IDSentToR4");
}

void OMAnimatedScheduler::IDSentToR3_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.IDSentToR3");
}

void OMAnimatedScheduler::IDSentToR2_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.IDSentToR2");
}

void OMAnimatedScheduler::IDSentToR1_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.IDSentToR1");
}

void OMAnimatedScheduler::AllAckReceived_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.state_80.InitializingState.ROOT.InitializingState.AllAckReceived");
}

IMPLEMENT_REACTIVE_META_S(Scheduler, false, iRouterScheduler1, OMAnimatediRouterScheduler1, OMAnimatedScheduler)
OMINIT_SUPERCLASS(iRouterScheduler1, OMAnimatediRouterScheduler1)
OMREGISTER_REACTIVE_CLASS
#endif // _OMINSTRUMENT


/*********************************************************************
	File Path	: mainComponent/DefaultConfig/Scheduler.cpp
*********************************************************************/

