/*********************************************************************
	Rhapsody	: 6.1 
	Login		: Masood Khosroshahy
	Component	: mainComponent 
	Configuration 	: DefaultConfig
	Model Element	: Scheduler
//!	Generated Date	: Tue, 28, Mar 2006  
	File Path	: mainComponent/DefaultConfig/Scheduler.h
*********************************************************************/


#ifndef Scheduler_H 

#define Scheduler_H 

#include <oxf/oxf.h>
#include <aom/aom.h>
#include "Rip.h"
// class Scheduler 
#include "iRouterScheduler1.h"
// class OutBound 
#include "iSchedulerRouter3.h"
#include <oxf/OMDefaultReactivePort.h>

//## package Rip 

//----------------------------------------------------------------------------
// Scheduler.h                                                                  
//----------------------------------------------------------------------------

#ifdef _OMINSTRUMENT
class OMAnimatedScheduler;
#endif // _OMINSTRUMENT


//## class Scheduler 
class Scheduler : public iRouterScheduler1 {
public :
    class pRouter1_C;
    class pRouter2_C;
    class pRouter3_C;
    class pRouter4_C;
    class pTimerOut_C;
    class pTimerIn_C;
    
public :
    //#[ ignore 
    typedef pRouter1_C *pRouter_CPtr;
    //#]
    
    
public :
    
        
        //## ignore 
        class pRouter1_C  {
        public :
            class InBound_C;
            class OutBound_C;
            
        public :
            
                
                //## ignore 
                class InBound_C : public iRouterScheduler1 {
                
                
                ////    Constructors and destructors    ////
                public :
                    
                    //## auto_generated 
                    InBound_C();
                    
                    //## auto_generated 
                    virtual ~InBound_C();
                
                
                ////    Operations    ////
                public :
                    
                    //## operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
                    bool send(IOxfEvent* event, const IOxfEventGenerationParams& params);
                    
                    //## operation send(IOxfEvent*) 
                    bool send(IOxfEvent* event);
                
                
                ////    Additional operations    ////
                public :
                    
                    //## auto_generated 
                    iRouterScheduler1* getItsIRouterScheduler1() const;
                    
                    //## auto_generated 
                    void setItsIRouterScheduler1(iRouterScheduler1* p_iRouterScheduler1);
                    
                    //## auto_generated 
                    pRouter1_C* getPort() const;
                    
                    //## auto_generated 
                    void setPort(pRouter1_C* p_pRouter1_C);
                
                
                ////    Framework operations    ////
                public :
                    
                    //## auto_generated 
                    void __setPort(pRouter1_C* p_pRouter1_C);
                    
                    //## auto_generated 
                    void _setPort(pRouter1_C* p_pRouter1_C);
                    
                    //## auto_generated 
                    void _clearPort();
                
                protected :
                    
                    //## auto_generated 
                    void cleanUpRelations();
                
                
                ////    Relations and components    ////
                protected :
                    
                    iRouterScheduler1* itsIRouterScheduler1;		//## link itsIRouterScheduler1 
                    
                    
                    pRouter1_C* port;		//## link port 
                    
                
                
                };
                
            
                
                //## ignore 
                class OutBound_C : public iSchedulerRouter3 {
                
                
                ////    Constructors and destructors    ////
                public :
                    
                    //## auto_generated 
                    OutBound_C();
                    
                    //## auto_generated 
                    virtual ~OutBound_C();
                
                
                ////    Operations    ////
                public :
                    
                    //## operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
                    bool send(IOxfEvent* event, const IOxfEventGenerationParams& params);
                    
                    //## operation send(IOxfEvent*) 
                    bool send(IOxfEvent* event);
                
                
                ////    Additional operations    ////
                public :
                    
                    //## auto_generated 
                    OMReactive* getItsISchedulerRouter3() const;
                    
                    //## auto_generated 
                    void setItsISchedulerRouter3(OMReactive* p_OMReactive);
                
                
                ////    Framework operations    ////
                protected :
                    
                    //## auto_generated 
                    void cleanUpRelations();
                
                
                ////    Relations and components    ////
                protected :
                    
                    OMReactive* itsISchedulerRouter3;		//## link itsISchedulerRouter3 
                    
                
                
                };
                
            
        //## ignore 
        
        
        ////    Constructors and destructors    ////
        public :
            
            //## auto_generated 
            pRouter1_C();
            
            //## auto_generated 
            virtual ~pRouter1_C();
        
        
        ////    Operations    ////
        public :
            
            //## operation connectScheduler(Scheduler*) 
            void connectScheduler(Scheduler* part);
            
            //## operation getItsIRouterScheduler1() 
            iRouterScheduler1* getItsIRouterScheduler1();
            
            //## operation getItsISchedulerRouter3() 
            iSchedulerRouter3* getItsISchedulerRouter3();
            
            //## operation setItsIRouterScheduler1(iRouterScheduler1*) 
            void setItsIRouterScheduler1(iRouterScheduler1* p_iRouterScheduler1);
            
            //## operation setItsISchedulerRouter3(OMReactive*) 
            void setItsISchedulerRouter3(OMReactive* p_iSchedulerRouter3);
        
        
        ////    Additional operations    ////
        public :
            
            //## auto_generated 
            InBound_C* getInBound() const;
            
            //## auto_generated 
            OutBound_C* getOutBound() const;
        
        
        ////    Framework operations    ////
        public :
            
            //## auto_generated 
            void destroy();
        
        protected :
            
            //## auto_generated 
            void initRelations();
        
        
        ////    Attributes    ////
        protected :
            
            int _p_;		//## attribute _p_ 
            
        
        ////    Relations and components    ////
        protected :
            
            InBound_C InBound;		//## classInstance InBound 
            
            
            OutBound_C OutBound;		//## classInstance OutBound 
            
        
        
        };
        
    
        
        //## ignore 
        class pRouter2_C  {
        public :
            class InBound_C;
            class OutBound_C;
            
        public :
            
                
                //## ignore 
                class InBound_C : public iRouterScheduler1 {
                
                
                ////    Constructors and destructors    ////
                public :
                    
                    //## auto_generated 
                    InBound_C();
                    
                    //## auto_generated 
                    virtual ~InBound_C();
                
                
                ////    Operations    ////
                public :
                    
                    //## operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
                    bool send(IOxfEvent* event, const IOxfEventGenerationParams& params);
                    
                    //## operation send(IOxfEvent*) 
                    bool send(IOxfEvent* event);
                
                
                ////    Additional operations    ////
                public :
                    
                    //## auto_generated 
                    iRouterScheduler1* getItsIRouterScheduler1() const;
                    
                    //## auto_generated 
                    void setItsIRouterScheduler1(iRouterScheduler1* p_iRouterScheduler1);
                    
                    //## auto_generated 
                    pRouter2_C* getPort() const;
                    
                    //## auto_generated 
                    void setPort(pRouter2_C* p_pRouter2_C);
                
                
                ////    Framework operations    ////
                public :
                    
                    //## auto_generated 
                    void __setPort(pRouter2_C* p_pRouter2_C);
                    
                    //## auto_generated 
                    void _setPort(pRouter2_C* p_pRouter2_C);
                    
                    //## auto_generated 
                    void _clearPort();
                
                protected :
                    
                    //## auto_generated 
                    void cleanUpRelations();
                
                
                ////    Relations and components    ////
                protected :
                    
                    iRouterScheduler1* itsIRouterScheduler1;		//## link itsIRouterScheduler1 
                    
                    
                    pRouter2_C* port;		//## link port 
                    
                
                
                };
                
            
                
                //## ignore 
                class OutBound_C : public iSchedulerRouter3 {
                
                
                ////    Constructors and destructors    ////
                public :
                    
                    //## auto_generated 
                    OutBound_C();
                    
                    //## auto_generated 
                    virtual ~OutBound_C();
                
                
                ////    Operations    ////
                public :
                    
                    //## operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
                    bool send(IOxfEvent* event, const IOxfEventGenerationParams& params);
                    
                    //## operation send(IOxfEvent*) 
                    bool send(IOxfEvent* event);
                
                
                ////    Additional operations    ////
                public :
                    
                    //## auto_generated 
                    OMReactive* getItsISchedulerRouter3() const;
                    
                    //## auto_generated 
                    void setItsISchedulerRouter3(OMReactive* p_OMReactive);
                
                
                ////    Framework operations    ////
                protected :
                    
                    //## auto_generated 
                    void cleanUpRelations();
                
                
                ////    Relations and components    ////
                protected :
                    
                    OMReactive* itsISchedulerRouter3;		//## link itsISchedulerRouter3 
                    
                
                
                };
                
            
        //## ignore 
        
        
        ////    Constructors and destructors    ////
        public :
            
            //## auto_generated 
            pRouter2_C();
            
            //## auto_generated 
            virtual ~pRouter2_C();
        
        
        ////    Operations    ////
        public :
            
            //## operation connectScheduler(Scheduler*) 
            void connectScheduler(Scheduler* part);
            
            //## operation getItsIRouterScheduler1() 
            iRouterScheduler1* getItsIRouterScheduler1();
            
            //## operation getItsISchedulerRouter3() 
            iSchedulerRouter3* getItsISchedulerRouter3();
            
            //## operation setItsIRouterScheduler1(iRouterScheduler1*) 
            void setItsIRouterScheduler1(iRouterScheduler1* p_iRouterScheduler1);
            
            //## operation setItsISchedulerRouter3(OMReactive*) 
            void setItsISchedulerRouter3(OMReactive* p_iSchedulerRouter3);
        
        
        ////    Additional operations    ////
        public :
            
            //## auto_generated 
            InBound_C* getInBound() const;
            
            //## auto_generated 
            OutBound_C* getOutBound() const;
        
        
        ////    Framework operations    ////
        public :
            
            //## auto_generated 
            void destroy();
        
        protected :
            
            //## auto_generated 
            void initRelations();
        
        
        ////    Attributes    ////
        protected :
            
            int _p_;		//## attribute _p_ 
            
        
        ////    Relations and components    ////
        protected :
            
            InBound_C InBound;		//## classInstance InBound 
            
            
            OutBound_C OutBound;		//## classInstance OutBound 
            
        
        
        };
        
    
        
        //## ignore 
        class pRouter3_C  {
        public :
            class InBound_C;
            class OutBound_C;
            
        public :
            
                
                //## ignore 
                class InBound_C : public iRouterScheduler1 {
                
                
                ////    Constructors and destructors    ////
                public :
                    
                    //## auto_generated 
                    InBound_C();
                    
                    //## auto_generated 
                    virtual ~InBound_C();
                
                
                ////    Operations    ////
                public :
                    
                    //## operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
                    bool send(IOxfEvent* event, const IOxfEventGenerationParams& params);
                    
                    //## operation send(IOxfEvent*) 
                    bool send(IOxfEvent* event);
                
                
                ////    Additional operations    ////
                public :
                    
                    //## auto_generated 
                    iRouterScheduler1* getItsIRouterScheduler1() const;
                    
                    //## auto_generated 
                    void setItsIRouterScheduler1(iRouterScheduler1* p_iRouterScheduler1);
                    
                    //## auto_generated 
                    pRouter3_C* getPort() const;
                    
                    //## auto_generated 
                    void setPort(pRouter3_C* p_pRouter3_C);
                
                
                ////    Framework operations    ////
                public :
                    
                    //## auto_generated 
                    void __setPort(pRouter3_C* p_pRouter3_C);
                    
                    //## auto_generated 
                    void _setPort(pRouter3_C* p_pRouter3_C);
                    
                    //## auto_generated 
                    void _clearPort();
                
                protected :
                    
                    //## auto_generated 
                    void cleanUpRelations();
                
                
                ////    Relations and components    ////
                protected :
                    
                    iRouterScheduler1* itsIRouterScheduler1;		//## link itsIRouterScheduler1 
                    
                    
                    pRouter3_C* port;		//## link port 
                    
                
                
                };
                
            
                
                //## ignore 
                class OutBound_C : public iSchedulerRouter3 {
                
                
                ////    Constructors and destructors    ////
                public :
                    
                    //## auto_generated 
                    OutBound_C();
                    
                    //## auto_generated 
                    virtual ~OutBound_C();
                
                
                ////    Operations    ////
                public :
                    
                    //## operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
                    bool send(IOxfEvent* event, const IOxfEventGenerationParams& params);
                    
                    //## operation send(IOxfEvent*) 
                    bool send(IOxfEvent* event);
                
                
                ////    Additional operations    ////
                public :
                    
                    //## auto_generated 
                    OMReactive* getItsISchedulerRouter3() const;
                    
                    //## auto_generated 
                    void setItsISchedulerRouter3(OMReactive* p_OMReactive);
                
                
                ////    Framework operations    ////
                protected :
                    
                    //## auto_generated 
                    void cleanUpRelations();
                
                
                ////    Relations and components    ////
                protected :
                    
                    OMReactive* itsISchedulerRouter3;		//## link itsISchedulerRouter3 
                    
                
                
                };
                
            
        //## ignore 
        
        
        ////    Constructors and destructors    ////
        public :
            
            //## auto_generated 
            pRouter3_C();
            
            //## auto_generated 
            virtual ~pRouter3_C();
        
        
        ////    Operations    ////
        public :
            
            //## operation connectScheduler(Scheduler*) 
            void connectScheduler(Scheduler* part);
            
            //## operation getItsIRouterScheduler1() 
            iRouterScheduler1* getItsIRouterScheduler1();
            
            //## operation getItsISchedulerRouter3() 
            iSchedulerRouter3* getItsISchedulerRouter3();
            
            //## operation setItsIRouterScheduler1(iRouterScheduler1*) 
            void setItsIRouterScheduler1(iRouterScheduler1* p_iRouterScheduler1);
            
            //## operation setItsISchedulerRouter3(OMReactive*) 
            void setItsISchedulerRouter3(OMReactive* p_iSchedulerRouter3);
        
        
        ////    Additional operations    ////
        public :
            
            //## auto_generated 
            InBound_C* getInBound() const;
            
            //## auto_generated 
            OutBound_C* getOutBound() const;
        
        
        ////    Framework operations    ////
        public :
            
            //## auto_generated 
            void destroy();
        
        protected :
            
            //## auto_generated 
            void initRelations();
        
        
        ////    Attributes    ////
        protected :
            
            int _p_;		//## attribute _p_ 
            
        
        ////    Relations and components    ////
        protected :
            
            InBound_C InBound;		//## classInstance InBound 
            
            
            OutBound_C OutBound;		//## classInstance OutBound 
            
        
        
        };
        
    
        
        //## ignore 
        class pRouter4_C  {
        public :
            class InBound_C;
            class OutBound_C;
            
        public :
            
                
                //## ignore 
                class InBound_C : public iRouterScheduler1 {
                
                
                ////    Constructors and destructors    ////
                public :
                    
                    //## auto_generated 
                    InBound_C();
                    
                    //## auto_generated 
                    virtual ~InBound_C();
                
                
                ////    Operations    ////
                public :
                    
                    //## operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
                    bool send(IOxfEvent* event, const IOxfEventGenerationParams& params);
                    
                    //## operation send(IOxfEvent*) 
                    bool send(IOxfEvent* event);
                
                
                ////    Additional operations    ////
                public :
                    
                    //## auto_generated 
                    iRouterScheduler1* getItsIRouterScheduler1() const;
                    
                    //## auto_generated 
                    void setItsIRouterScheduler1(iRouterScheduler1* p_iRouterScheduler1);
                    
                    //## auto_generated 
                    pRouter4_C* getPort() const;
                    
                    //## auto_generated 
                    void setPort(pRouter4_C* p_pRouter4_C);
                
                
                ////    Framework operations    ////
                public :
                    
                    //## auto_generated 
                    void __setPort(pRouter4_C* p_pRouter4_C);
                    
                    //## auto_generated 
                    void _setPort(pRouter4_C* p_pRouter4_C);
                    
                    //## auto_generated 
                    void _clearPort();
                
                protected :
                    
                    //## auto_generated 
                    void cleanUpRelations();
                
                
                ////    Relations and components    ////
                protected :
                    
                    iRouterScheduler1* itsIRouterScheduler1;		//## link itsIRouterScheduler1 
                    
                    
                    pRouter4_C* port;		//## link port 
                    
                
                
                };
                
            
                
                //## ignore 
                class OutBound_C : public iSchedulerRouter3 {
                
                
                ////    Constructors and destructors    ////
                public :
                    
                    //## auto_generated 
                    OutBound_C();
                    
                    //## auto_generated 
                    virtual ~OutBound_C();
                
                
                ////    Operations    ////
                public :
                    
                    //## operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
                    bool send(IOxfEvent* event, const IOxfEventGenerationParams& params);
                    
                    //## operation send(IOxfEvent*) 
                    bool send(IOxfEvent* event);
                
                
                ////    Additional operations    ////
                public :
                    
                    //## auto_generated 
                    OMReactive* getItsISchedulerRouter3() const;
                    
                    //## auto_generated 
                    void setItsISchedulerRouter3(OMReactive* p_OMReactive);
                
                
                ////    Framework operations    ////
                protected :
                    
                    //## auto_generated 
                    void cleanUpRelations();
                
                
                ////    Relations and components    ////
                protected :
                    
                    OMReactive* itsISchedulerRouter3;		//## link itsISchedulerRouter3 
                    
                
                
                };
                
            
        //## ignore 
        
        
        ////    Constructors and destructors    ////
        public :
            
            //## auto_generated 
            pRouter4_C();
            
            //## auto_generated 
            virtual ~pRouter4_C();
        
        
        ////    Operations    ////
        public :
            
            //## operation connectScheduler(Scheduler*) 
            void connectScheduler(Scheduler* part);
            
            //## operation getItsIRouterScheduler1() 
            iRouterScheduler1* getItsIRouterScheduler1();
            
            //## operation getItsISchedulerRouter3() 
            iSchedulerRouter3* getItsISchedulerRouter3();
            
            //## operation setItsIRouterScheduler1(iRouterScheduler1*) 
            void setItsIRouterScheduler1(iRouterScheduler1* p_iRouterScheduler1);
            
            //## operation setItsISchedulerRouter3(OMReactive*) 
            void setItsISchedulerRouter3(OMReactive* p_iSchedulerRouter3);
        
        
        ////    Additional operations    ////
        public :
            
            //## auto_generated 
            InBound_C* getInBound() const;
            
            //## auto_generated 
            OutBound_C* getOutBound() const;
        
        
        ////    Framework operations    ////
        public :
            
            //## auto_generated 
            void destroy();
        
        protected :
            
            //## auto_generated 
            void initRelations();
        
        
        ////    Attributes    ////
        protected :
            
            int _p_;		//## attribute _p_ 
            
        
        ////    Relations and components    ////
        protected :
            
            InBound_C InBound;		//## classInstance InBound 
            
            
            OutBound_C OutBound;		//## classInstance OutBound 
            
        
        
        };
        
    
        
        //## ignore 
        class pTimerOut_C : public OMDefaultReactivePort {
        
        
        ////    Constructors and destructors    ////
        public :
            
            //## auto_generated 
            pTimerOut_C();
            
            //## auto_generated 
            virtual ~pTimerOut_C();
        
        
        ////    Operations    ////
        public :
            
            //## operation connectScheduler(Scheduler*) 
            void connectScheduler(Scheduler* part);
        
        
        ////    Attributes    ////
        protected :
            
            int _p_;		//## attribute _p_ 
            
        
        };
        
    
        
        //## ignore 
        class pTimerIn_C : public OMDefaultReactivePort {
        
        
        ////    Constructors and destructors    ////
        public :
            
            //## auto_generated 
            pTimerIn_C();
            
            //## auto_generated 
            virtual ~pTimerIn_C();
        
        
        ////    Operations    ////
        public :
            
            //## operation connectScheduler(Scheduler*) 
            void connectScheduler(Scheduler* part);
        
        
        ////    Attributes    ////
        protected :
            
            int _p_;		//## attribute _p_ 
            
        
        };
        
    
//## class Scheduler 


////    Friends    ////
public :
    
    
#ifdef _OMINSTRUMENT
    friend  class OMAnimatedScheduler;
#endif // _OMINSTRUMENT


////    Constructors and destructors    ////
public :
    
    //## auto_generated 
    Scheduler(IOxfActive* theActiveContext = 0);
    
    //## auto_generated 
    ~Scheduler();


////    Operations    ////
public :
    
    //## operation sendingTimerToAll() 
    void sendingTimerToAll();
    
    //## operation setReplyTo(void *) 
    void setReplyTo(void * p);


////    Additional operations    ////
public :
    
    //## auto_generated 
    pRouter1_C* getPRouter1() const;
    
    //## auto_generated 
    pRouter1_C* get_pRouter1() const;
    
    //## auto_generated 
    pRouter1_C* newPRouter1();
    
    //## auto_generated 
    void deletePRouter1();
    
    //## auto_generated 
    pRouter2_C* getPRouter2() const;
    
    //## auto_generated 
    pRouter2_C* get_pRouter2() const;
    
    //## auto_generated 
    pRouter2_C* newPRouter2();
    
    //## auto_generated 
    void deletePRouter2();
    
    //## auto_generated 
    pRouter3_C* getPRouter3() const;
    
    //## auto_generated 
    pRouter3_C* get_pRouter3() const;
    
    //## auto_generated 
    pRouter3_C* newPRouter3();
    
    //## auto_generated 
    void deletePRouter3();
    
    //## auto_generated 
    pRouter4_C* getPRouter4() const;
    
    //## auto_generated 
    pRouter4_C* get_pRouter4() const;
    
    //## auto_generated 
    pRouter4_C* newPRouter4();
    
    //## auto_generated 
    void deletePRouter4();
    
    //## auto_generated 
    pTimerOut_C* getPTimerOut() const;
    
    //## auto_generated 
    pTimerOut_C* get_pTimerOut() const;
    
    //## auto_generated 
    pTimerOut_C* newPTimerOut();
    
    //## auto_generated 
    void deletePTimerOut();
    
    //## auto_generated 
    pTimerIn_C* getPTimerIn() const;
    
    //## auto_generated 
    pTimerIn_C* get_pTimerIn() const;
    
    //## auto_generated 
    pTimerIn_C* newPTimerIn();
    
    //## auto_generated 
    void deletePTimerIn();
    
    //## auto_generated 
    int getNbNodes() const;
    
    //## auto_generated 
    void setNbNodes(int p_NbNodes);
    
    //## auto_generated 
    pRouter_CPtr getReplyTo() const;
    
    //## auto_generated 
    void setReplyTo(pRouter_CPtr p_replyTo);
    
    //## auto_generated 
    int getRipMessageSendingIteration() const;
    
    //## auto_generated 
    void setRipMessageSendingIteration(int p_ripMessageSendingIteration);
    
    //## auto_generated 
    int getTime() const;
    
    //## auto_generated 
    void setTime(int p_time);


////    Framework operations    ////
public :
    
    //rootState:
    
    //## statechart_method 
    inline bool rootState_IN() const;
    
    //## statechart_method 
    inline bool rootState_isCompleted();
    
    //## statechart_method 
    virtual void rootState_entDef();
    
    //## statechart_method 
    virtual IOxfReactive::TakeEventStatus rootState_processEvent();
    
    //mainState:
    
    //## statechart_method 
    inline bool mainState_IN() const;
    
    //## statechart_method 
    bool mainState_isCompleted();
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus mainState_processEvent();
    
    //state_81:
    
    //## statechart_method 
    inline bool state_81_IN() const;
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus state_81_processEvent();
    
    //NewTopologyAt75:
    
    //## statechart_method 
    inline bool NewTopologyAt75_IN() const;
    
    //NewTopologyAt195:
    
    //## statechart_method 
    inline bool NewTopologyAt195_IN() const;
    
    //NewTopologyAt135:
    
    //## statechart_method 
    inline bool NewTopologyAt135_IN() const;
    
    //InitialTimerState:
    
    //## statechart_method 
    inline bool InitialTimerState_IN() const;
    
    //evTimerSent:
    
    //## statechart_method 
    inline bool evTimerSent_IN() const;
    
    //state_80:
    
    //## statechart_method 
    inline bool state_80_IN() const;
    
    //## statechart_method 
    inline bool state_80_isCompleted();
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus state_80_processEvent();
    
    //Wait_42_down:
    
    //## statechart_method 
    inline bool Wait_42_down_IN() const;
    
    //Wait_41_Down:
    
    //## statechart_method 
    inline bool Wait_41_Down_IN() const;
    
    //Wait_32_Down:
    
    //## statechart_method 
    inline bool Wait_32_Down_IN() const;
    
    //TopologyToR4_42:
    
    //## statechart_method 
    inline bool TopologyToR4_42_IN() const;
    
    //TopologyToR4_41:
    
    //## statechart_method 
    inline bool TopologyToR4_41_IN() const;
    
    //TopologyToR3_32:
    
    //## statechart_method 
    inline bool TopologyToR3_32_IN() const;
    
    //TopologyToR2_42:
    
    //## statechart_method 
    inline bool TopologyToR2_42_IN() const;
    
    //TopologyToR2_32:
    
    //## statechart_method 
    inline bool TopologyToR2_32_IN() const;
    
    //TopologyToR1_41:
    
    //## statechart_method 
    inline bool TopologyToR1_41_IN() const;
    
    //state_74:
    
    //## statechart_method 
    inline bool state_74_IN() const;
    
    //InitializingState:
    
    //## statechart_method 
    inline bool InitializingState_IN() const;
    
    //Topology:
    
    //## statechart_method 
    inline bool Topology_IN() const;
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus Topology_processEvent();
    
    //state_63:
    
    //## statechart_method 
    inline bool state_63_IN() const;
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus state_63_processEvent();
    
    //TopologyToR3:
    
    //## statechart_method 
    inline bool TopologyToR3_IN() const;
    
    //SendingToR3:
    
    //## statechart_method 
    inline bool SendingToR3_IN() const;
    
    //Ack3:
    
    //## statechart_method 
    inline bool Ack3_IN() const;
    
    //state_62:
    
    //## statechart_method 
    inline bool state_62_IN() const;
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus state_62_processEvent();
    
    //TopologyToR2:
    
    //## statechart_method 
    inline bool TopologyToR2_IN() const;
    
    //SendingToR2:
    
    //## statechart_method 
    inline bool SendingToR2_IN() const;
    
    //Ack2:
    
    //## statechart_method 
    inline bool Ack2_IN() const;
    
    //state_61:
    
    //## statechart_method 
    inline bool state_61_IN() const;
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus state_61_processEvent();
    
    //TopologyTo4:
    
    //## statechart_method 
    inline bool TopologyTo4_IN() const;
    
    //SendingToR4:
    
    //## statechart_method 
    inline bool SendingToR4_IN() const;
    
    //Ack4:
    
    //## statechart_method 
    inline bool Ack4_IN() const;
    
    //state_60:
    
    //## statechart_method 
    inline bool state_60_IN() const;
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus state_60_processEvent();
    
    //TopologyToR1:
    
    //## statechart_method 
    inline bool TopologyToR1_IN() const;
    
    //SendingToR1:
    
    //## statechart_method 
    inline bool SendingToR1_IN() const;
    
    //Ack1:
    
    //## statechart_method 
    inline bool Ack1_IN() const;
    
    //Initial:
    
    //## statechart_method 
    inline bool Initial_IN() const;
    
    //IDSentToR4:
    
    //## statechart_method 
    inline bool IDSentToR4_IN() const;
    
    //IDSentToR3:
    
    //## statechart_method 
    inline bool IDSentToR3_IN() const;
    
    //IDSentToR2:
    
    //## statechart_method 
    inline bool IDSentToR2_IN() const;
    
    //IDSentToR1:
    
    //## statechart_method 
    inline bool IDSentToR1_IN() const;
    
    //AllAckReceived:
    
    //## statechart_method 
    inline bool AllAckReceived_IN() const;
    
    //## auto_generated 
    virtual bool startBehavior();
    
    //## statechart_method 
    void state_60_entDef();
    
    //## statechart_method 
    void state_81_exit();
    
    //## statechart_method 
    void state_63_entDef();
    
    //## statechart_method 
    void state_80_exit();
    
    //## statechart_method 
    void mainState_entDef();
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus Ack2_handleEvent();
    
    //## statechart_method 
    void state_61_entDef();
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus Topology_handleEvent();
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus IDSentToR4_handleEvent();
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus Ack3_handleEvent();
    
    //## statechart_method 
    void state_80_entDef();
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus InitialTimerState_handleEvent();
    
    //## statechart_method 
    void Topology_entDef();
    
    //## statechart_method 
    void InitializingState_entDef();
    
    //## statechart_method 
    void state_62_entDef();
    
    //## statechart_method 
    void InitializingState_exit();
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus IDSentToR4TakeNull();
    
    //## statechart_method 
    void Topology_exit();
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus Ack1_handleEvent();
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus Ack4_handleEvent();
    
    //## statechart_method 
    void state_81_entDef();
    
    //## statechart_method 
    void mainState_exit();

protected :
    
    //## auto_generated 
    void initRelations();
    
    //## auto_generated 
    void initStatechart();
    
    //## auto_generated 
    void cleanUpRelations();
    
    //## auto_generated 
    void cancelTimeouts();
    
    //## auto_generated 
    bool cancelTimeout(const IOxfTimeout* arg);


////    Attributes    ////
protected :
    
    int NbNodes;		//## attribute NbNodes 
    
    pRouter_CPtr replyTo;		//## attribute replyTo 
    
    int ripMessageSendingIteration;		//## attribute ripMessageSendingIteration 
    
    int time;		//## attribute time 
    
    IOxfTimeout* NewTopologyAt75_timeout;		//## ignore 
    
    IOxfTimeout* NewTopologyAt195_timeout;		//## ignore 
    
    IOxfTimeout* NewTopologyAt135_timeout;		//## ignore 
    
    IOxfTimeout* InitialTimerState_timeout;		//## ignore 
    

////    Relations and components    ////
protected :
    
    pRouter1_C* pRouter1;		//## classInstance pRouter1 
    
    
    pRouter2_C* pRouter2;		//## classInstance pRouter2 
    
    
    pRouter3_C* pRouter3;		//## classInstance pRouter3 
    
    
    pRouter4_C* pRouter4;		//## classInstance pRouter4 
    
    
    pTimerOut_C* pTimerOut;		//## classInstance pTimerOut 
    
    
    pTimerIn_C* pTimerIn;		//## classInstance pTimerIn 
    


////    Framework    ////
protected :
    
    //#[ ignore 
    //states enumeration: 
    enum Scheduler_Enum{ OMNonState=0, mainState=1, state_81=2, NewTopologyAt75=3, 
        NewTopologyAt195=4, NewTopologyAt135=5, InitialTimerState=6, evTimerSent=7, 
        state_80=8, Wait_42_down=9, Wait_41_Down=10, Wait_32_Down=11, 
        TopologyToR4_42=12, TopologyToR4_41=13, TopologyToR3_32=14, TopologyToR2_42=15, 
        TopologyToR2_32=16, TopologyToR1_41=17, state_74=18, InitializingState=19, 
        Topology=20, state_63=21, TopologyToR3=22, SendingToR3=23, 
        Ack3=24, state_62=25, TopologyToR2=26, SendingToR2=27, 
        Ack2=28, state_61=29, TopologyTo4=30, SendingToR4=31, 
        Ack4=32, state_60=33, TopologyToR1=34, SendingToR1=35, 
        Ack1=36, Initial=37, IDSentToR4=38, IDSentToR3=39, IDSentToR2=40, IDSentToR1=41, AllAckReceived=42 };
        //#]
    
    int rootState_subState;		//## ignore 
    
    
    int rootState_active;		//## ignore 
    
    
    int state_81_subState;		//## ignore 
    
    
    int state_81_active;		//## ignore 
    
    
    int state_80_subState;		//## ignore 
    
    
    int state_80_active;		//## ignore 
    
    
    int InitializingState_subState;		//## ignore 
    
    
    int state_63_subState;		//## ignore 
    
    
    int state_63_active;		//## ignore 
    
    
    int state_62_subState;		//## ignore 
    
    
    int state_62_active;		//## ignore 
    
    
    int state_61_subState;		//## ignore 
    
    
    int state_61_active;		//## ignore 
    
    
    int state_60_subState;		//## ignore 
    
    
    int state_60_active;		//## ignore 
    

};
//---------------------------------------------------------------------------- 
// inline operations for Scheduler
//---------------------------------------------------------------------------- 

inline bool Scheduler::rootState_IN() const {
    return true;
}

inline bool Scheduler::rootState_isCompleted() {
    return true;
}

inline bool Scheduler::mainState_IN() const {
    return rootState_subState == mainState;
}

inline bool Scheduler::state_81_IN() const {
    return mainState_IN();
}

inline bool Scheduler::NewTopologyAt75_IN() const {
    return state_81_subState == NewTopologyAt75;
}

inline bool Scheduler::NewTopologyAt195_IN() const {
    return state_81_subState == NewTopologyAt195;
}

inline bool Scheduler::NewTopologyAt135_IN() const {
    return state_81_subState == NewTopologyAt135;
}

inline bool Scheduler::InitialTimerState_IN() const {
    return state_81_subState == InitialTimerState;
}

inline bool Scheduler::evTimerSent_IN() const {
    return state_81_subState == evTimerSent;
}

inline bool Scheduler::state_80_IN() const {
    return mainState_IN();
}

inline bool Scheduler::state_80_isCompleted() {
    return ( IS_IN(state_74) );
}

inline bool Scheduler::Wait_42_down_IN() const {
    return state_80_subState == Wait_42_down;
}

inline bool Scheduler::Wait_41_Down_IN() const {
    return state_80_subState == Wait_41_Down;
}

inline bool Scheduler::Wait_32_Down_IN() const {
    return state_80_subState == Wait_32_Down;
}

inline bool Scheduler::TopologyToR4_42_IN() const {
    return state_80_subState == TopologyToR4_42;
}

inline bool Scheduler::TopologyToR4_41_IN() const {
    return state_80_subState == TopologyToR4_41;
}

inline bool Scheduler::TopologyToR3_32_IN() const {
    return state_80_subState == TopologyToR3_32;
}

inline bool Scheduler::TopologyToR2_42_IN() const {
    return state_80_subState == TopologyToR2_42;
}

inline bool Scheduler::TopologyToR2_32_IN() const {
    return state_80_subState == TopologyToR2_32;
}

inline bool Scheduler::TopologyToR1_41_IN() const {
    return state_80_subState == TopologyToR1_41;
}

inline bool Scheduler::state_74_IN() const {
    return state_80_subState == state_74;
}

inline bool Scheduler::InitializingState_IN() const {
    return state_80_subState == InitializingState;
}

inline bool Scheduler::Topology_IN() const {
    return InitializingState_subState == Topology;
}

inline bool Scheduler::state_63_IN() const {
    return Topology_IN();
}

inline bool Scheduler::TopologyToR3_IN() const {
    return state_63_subState == TopologyToR3;
}

inline bool Scheduler::SendingToR3_IN() const {
    return state_63_subState == SendingToR3;
}

inline bool Scheduler::Ack3_IN() const {
    return state_63_subState == Ack3;
}

inline bool Scheduler::state_62_IN() const {
    return Topology_IN();
}

inline bool Scheduler::TopologyToR2_IN() const {
    return state_62_subState == TopologyToR2;
}

inline bool Scheduler::SendingToR2_IN() const {
    return state_62_subState == SendingToR2;
}

inline bool Scheduler::Ack2_IN() const {
    return state_62_subState == Ack2;
}

inline bool Scheduler::state_61_IN() const {
    return Topology_IN();
}

inline bool Scheduler::TopologyTo4_IN() const {
    return state_61_subState == TopologyTo4;
}

inline bool Scheduler::SendingToR4_IN() const {
    return state_61_subState == SendingToR4;
}

inline bool Scheduler::Ack4_IN() const {
    return state_61_subState == Ack4;
}

inline bool Scheduler::state_60_IN() const {
    return Topology_IN();
}

inline bool Scheduler::TopologyToR1_IN() const {
    return state_60_subState == TopologyToR1;
}

inline bool Scheduler::SendingToR1_IN() const {
    return state_60_subState == SendingToR1;
}

inline bool Scheduler::Ack1_IN() const {
    return state_60_subState == Ack1;
}

inline bool Scheduler::Initial_IN() const {
    return InitializingState_subState == Initial;
}

inline bool Scheduler::IDSentToR4_IN() const {
    return InitializingState_subState == IDSentToR4;
}

inline bool Scheduler::IDSentToR3_IN() const {
    return InitializingState_subState == IDSentToR3;
}

inline bool Scheduler::IDSentToR2_IN() const {
    return InitializingState_subState == IDSentToR2;
}

inline bool Scheduler::IDSentToR1_IN() const {
    return InitializingState_subState == IDSentToR1;
}

inline bool Scheduler::AllAckReceived_IN() const {
    return InitializingState_subState == AllAckReceived;
}

















#ifdef _OMINSTRUMENT
//## ignore 
class OMAnimatedScheduler : public OMAnimatediRouterScheduler1 {

    
    DECLARE_REACTIVE_META(Scheduler, OMAnimatedScheduler)


////    Framework operations    ////
public :
    
    virtual void serializeAttributes(AOMSAttributes* aomsAttributes) const;
    
    virtual void serializeRelations(AOMSRelations* aomsRelations) const;
    
    //## statechart_method 
    void rootState_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void mainState_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void state_81_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void NewTopologyAt75_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void NewTopologyAt195_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void NewTopologyAt135_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void InitialTimerState_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void evTimerSent_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void state_80_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void Wait_42_down_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void Wait_41_Down_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void Wait_32_Down_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void TopologyToR4_42_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void TopologyToR4_41_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void TopologyToR3_32_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void TopologyToR2_42_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void TopologyToR2_32_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void TopologyToR1_41_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void state_74_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void InitializingState_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void Topology_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void state_63_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void TopologyToR3_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void SendingToR3_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void Ack3_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void state_62_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void TopologyToR2_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void SendingToR2_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void Ack2_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void state_61_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void TopologyTo4_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void SendingToR4_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void Ack4_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void state_60_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void TopologyToR1_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void SendingToR1_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void Ack1_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void Initial_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void IDSentToR4_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void IDSentToR3_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void IDSentToR2_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void IDSentToR1_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void AllAckReceived_serializeStates(AOMSState* aomsState) const;


};

#endif // _OMINSTRUMENT

#endif  
/*********************************************************************
	File Path	: mainComponent/DefaultConfig/Scheduler.h
*********************************************************************/

