/*********************************************************************
	Rhapsody	: 6.1 
	Login		: Masood Khosroshahy
	Component	: mainComponent 
	Configuration 	: DefaultConfig
	Model Element	: Network
//!	Generated Date	: Tue, 28, Mar 2006  
	File Path	: mainComponent/DefaultConfig/Network.h
*********************************************************************/


#ifndef Network_H 

#define Network_H 

#include <oxf/oxf.h>
#include <aom/aom.h>
#include "Rip.h"
#include <oxf/omthread.h>
#include <oxf/omreactive.h>
#include <oxf/state.h>
#include <oxf/event.h>
// classInstance r1 
#include "Router.h"
// classInstance scheduler 
#include "Scheduler.h"

//## package Rip 

//----------------------------------------------------------------------------
// Network.h                                                                  
//----------------------------------------------------------------------------

#ifdef _OMINSTRUMENT
class OMAnimatedNetwork;
#endif // _OMINSTRUMENT


//## class Network 
class Network : public OMReactive {


////    Friends    ////
public :
    
    
#ifdef _OMINSTRUMENT
    friend  class OMAnimatedNetwork;
#endif // _OMINSTRUMENT


////    Constructors and destructors    ////
public :
    
    //## auto_generated 
    Network(IOxfActive* theActiveContext = 0);
    
    //## auto_generated 
    ~Network();


////    Additional operations    ////
public :
    
    //## auto_generated 
    Router* getR1() const;
    
    //## auto_generated 
    Router* getR2() const;
    
    //## auto_generated 
    Router* getR3() const;
    
    //## auto_generated 
    Router* getR4() const;
    
    //## auto_generated 
    Scheduler* getScheduler() const;


////    Framework operations    ////
public :
    
    //## auto_generated 
    void destroy();
    
    //## auto_generated 
    virtual bool startBehavior();

protected :
    
    //## auto_generated 
    void initRelations();


////    Relations and components    ////
protected :
    
    Router r1;		//## classInstance r1 
    
    
    Router r2;		//## classInstance r2 
    
    
    Router r3;		//## classInstance r3 
    
    
    Router r4;		//## classInstance r4 
    
    
    Scheduler scheduler;		//## classInstance scheduler 
    


};


#ifdef _OMINSTRUMENT
//## ignore 
class OMAnimatedNetwork : virtual public AOMInstance {

    
    DECLARE_META(Network, OMAnimatedNetwork)


////    Framework operations    ////
public :
    
    virtual void serializeRelations(AOMSRelations* aomsRelations) const;


};

#endif // _OMINSTRUMENT

#endif  
/*********************************************************************
	File Path	: mainComponent/DefaultConfig/Network.h
*********************************************************************/

